"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = submitMSISDN;

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.regexp.search");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var getConfig = function getConfig() {
  try {
    var configs = require("../../../../../config.json");

    return configs;
  } catch (ex) {
    throw "config.json not found";
  }
};

function submitMSISDN(_x, _x2, _x3, _x4, _x5) {
  return _submitMSISDN.apply(this, arguments);
}

function _submitMSISDN() {
  _submitMSISDN = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(window, maybeConfig, msisdn, strategy, extraParams) {
    var config, _ref3, host, country, slug, offer, search, extraParamsQs;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            config = strategy ? _objectSpread({
              offer: window.pac_analytics.visitor.offer
            }, strategy.flowConfig) : !maybeConfig ? {
              offer: window.pac_analytics.visitor.offer
            } : maybeConfig;
            _ref3 = !config.host || !config.slug || !config.country ? _objectSpread({
              offer: window.pac_analytics.visitor.offer
            }, getConfig()) : config, host = _ref3.host, country = _ref3.country, slug = _ref3.slug, offer = _ref3.offer;
            search = window.location.search.substr(1) || '';
            extraParamsQs = !extraParams ? '' : '&' + Object.keys(extraParams).map(function (k) {
              return "".concat(k, "=").concat(extraParams[k]);
            }).join('&');

            if (!(country.toLowerCase() === 'pt')) {
              _context.next = 8;
              break;
            }

            return _context.abrupt("return", assrock_pt({
              host: host,
              country: country,
              slug: slug,
              offer: offer,
              msisdn: msisdn,
              extraParamsQs: extraParamsQs,
              search: search
            }));

          case 8:
            return _context.abrupt("return", assrock_v1({
              host: host,
              country: country,
              slug: slug,
              offer: offer,
              msisdn: msisdn,
              extraParamsQs: extraParamsQs,
              search: search
            }));

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _submitMSISDN.apply(this, arguments);
}

function assrock_v1(_x6) {
  return _assrock_v.apply(this, arguments);
}

function _assrock_v() {
  _assrock_v = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(_ref) {
    var host, country, slug, offer, msisdn, extraParamsQs, search, result, error;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            host = _ref.host, country = _ref.country, slug = _ref.slug, offer = _ref.offer, msisdn = _ref.msisdn, extraParamsQs = _ref.extraParamsQs, search = _ref.search;
            _context3.next = 3;
            return fetch("https://lp-api.sam-media.com/v1/submit_msisdn/".concat(host, "/").concat(country, "/").concat(slug || slug, "/").concat(offer, "/?msisdn=").concat(msisdn, "&rockman_id=").concat(window.pac_analytics.visitor.rockmanId).concat(extraParamsQs, "&").concat(search)).then(function (x) {
              return x.json();
            });

          case 3:
            result = _context3.sent;

            if (result.isValid) {
              _context3.next = 11;
              break;
            }

            error = new Error("".concat(result.errorType, ":\n").concat(result.errorText));
            error['type'] = result.errorType;
            console.error(error);
            throw error;

          case 11:
            return _context3.abrupt("return", /*#__PURE__*/function () {
              var _submitPIN = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(pin) {
                var pinResult, pinError;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.next = 2;
                        return fetch("https://lp-api.sam-media.com/v1/submit_pin?pin=".concat(pin, "&sid=").concat(result.submissionId)).then(function (x) {
                          return x.json();
                        });

                      case 2:
                        pinResult = _context2.sent;

                        if (pinResult.isValid) {
                          _context2.next = 9;
                          break;
                        }

                        pinError = new Error("".concat(pinResult.errorType, ":\n").concat(pinResult.errorText));
                        pinError['type'] = pinResult.errorType;
                        throw pinError;

                      case 9:
                        return _context2.abrupt("return", pinResult.finalUrl);

                      case 10:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              function submitPIN(_x8) {
                return _submitPIN.apply(this, arguments);
              }

              return submitPIN;
            }());

          case 12:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _assrock_v.apply(this, arguments);
}

function assrock_pt(_x7) {
  return _assrock_pt.apply(this, arguments);
}

function _assrock_pt() {
  _assrock_pt = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(_ref2) {
    var host, country, slug, offer, msisdn, extraParamsQs, search, result, error;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            host = _ref2.host, country = _ref2.country, slug = _ref2.slug, offer = _ref2.offer, msisdn = _ref2.msisdn, extraParamsQs = _ref2.extraParamsQs, search = _ref2.search;
            _context5.next = 3;
            return fetch("https://lp-api.sam-media.com/pt/v1/submit-phone?offer=".concat(offer, "&phone=").concat(msisdn, "&rockman_id=").concat(window.pac_analytics.visitor.rockmanId).concat(extraParamsQs, "&").concat(search)).then(function (x) {
              return x.json();
            });

          case 3:
            result = _context5.sent;

            if (!result.error) {
              _context5.next = 11;
              break;
            }

            error = new Error("".concat(result.error));
            error['type'] = result.error;
            console.error(error);
            throw error;

          case 11:
            return _context5.abrupt("return", /*#__PURE__*/function () {
              var _submitPIN2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(pin) {
                var pinResult, pinError;
                return regeneratorRuntime.wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        _context4.next = 2;
                        return fetch("https://lp-api.sam-media.com/pt/v1/submit-pin?pin=".concat(pin, "&submission_id=").concat(result.submission_id)).then(function (x) {
                          return x.json();
                        });

                      case 2:
                        pinResult = _context4.sent;

                        if (!pinResult.error) {
                          _context4.next = 9;
                          break;
                        }

                        pinError = new Error("".concat(pinResult.error));
                        pinError['type'] = pinResult.error;
                        throw pinError;

                      case 9:
                        return _context4.abrupt("return", pinResult.final_url);

                      case 10:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4);
              }));

              function submitPIN(_x9) {
                return _submitPIN2.apply(this, arguments);
              }

              return submitPIN;
            }());

          case 12:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _assrock_pt.apply(this, arguments);
}