"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Loader = Loader;
exports.default = exports.Variant = exports.Experiment = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.reflect.construct");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.object.to-string");

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var OptimizeContext = _react.default.createContext("");

function nothing() {
  return {
    tag: "Nothing"
  };
}

function just(v) {
  return {
    tag: "Just",
    value: v
  };
}

function maybe(defaultValue, m) {
  return m.tag === "Nothing" ? defaultValue : m.value;
}

var Experiment = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(Experiment, _React$PureComponent);

  var _super = _createSuper(Experiment);

  function Experiment() {
    var _this;

    _classCallCheck(this, Experiment);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      variant: nothing()
    });

    return _this;
  }

  _createClass(Experiment, [{
    key: "componentWillMount",
    //const gtag = (...args)=>{window.dataLayer.push(...args)}
    value: function componentWillMount() {
      var _this2 = this;

      if (typeof window != "undefined") {
        window.dataLayer.push({
          event: "optimizeEvent"
        });
        gtag('event', 'optimize.callback', {
          callback: function callback(_vId, experimentId) {
            console.log('optimize.callback experimentid', _vId, experimentId);
            var ga = window['ga'];

            if (!!ga) {
              var _expId = experimentId;
              var gtm = ga.getAll()[0].get('name');
              ga("".concat(gtm, ".set"), 'exp', _expId.toString() + '.' + _vId.toString());
              ga("".concat(gtm, ".send"), 'event', 'Experiment', 'Trigger', _expId.toString() + '.' + _vId.toString());

              _this2.setState({
                variant: just(_vId)
              });
            }
          }
        });
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this3 = this;

      setTimeout(function () {
        if (_this3.state.variant === null || _this3.state.variant.tag === "Nothing") {
          _this3.setState({
            variant: just("0")
          });
        }
      }, 750);
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react.default.createElement(OptimizeContext.Provider, {
        value: maybe("-1", this.state.variant)
      }, this.props.children);
    }
  }]);

  return Experiment;
}(_react.default.PureComponent);

exports.Experiment = Experiment;

_defineProperty(Experiment, "defaultProps", {
  loader: "Loading..."
});

function Loader(props) {
  return /*#__PURE__*/_react.default.createElement(Variant, {
    id: "-1"
  }, props.children);
}

var Variant = /*#__PURE__*/function (_React$Component) {
  _inherits(Variant, _React$Component);

  var _super2 = _createSuper(Variant);

  function Variant() {
    _classCallCheck(this, Variant);

    return _super2.apply(this, arguments);
  }

  _createClass(Variant, [{
    key: "render",
    value: function render() {
      var _this4 = this;

      return /*#__PURE__*/_react.default.createElement(OptimizeContext.Consumer, null, function (value) {
        return value === _this4.props.id ? _this4.props.children : null;
      });
    }
  }]);

  return Variant;
}(_react.default.Component);

exports.Variant = Variant;
var _default = {
  Experiment: Experiment,
  Variant: Variant
};
exports.default = _default;