"use strict";

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.weak-map");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.strategy = strategy;
exports.determineFlowByMsidn = determineFlowByMsidn;
exports.determineFlowByOperator = determineFlowByOperator;
exports.getOperators = getOperators;
exports.default = exports.mockedMORedirFlow = exports.mockedClick2smsFlow = exports.mockedOneClickFlow = exports.mockedMOFlow = exports.mockedPinFlow = exports.isTopLoading = exports.isMoRedirFlow = exports.isClic2SmsFlow = exports.isOneClickFlow = exports.isMOFlow = exports.isPINFlow = exports.isMSISDNEntry = exports.initialState = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.object.assign");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.reflect.construct");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.regexp.match");

require("core-js/modules/es6.promise");

require("regenerator-runtime/runtime");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.object.keys");

var React = _interopRequireWildcard(require("react"));

var RDS = _interopRequireWildcard(require("../../common-types/RemoteDataState"));

var TallymanPin_V1 = _interopRequireWildcard(require("../tallyman.v1-pin/HOC"));

var TallymanMo_V1 = _interopRequireWildcard(require("../tallyman.v1-mo/HOC"));

var TallymanMoRedir_V1 = _interopRequireWildcard(require("../tallyman.v1-moredir/HOC"));

var BupperOneClick = _interopRequireWildcard(require("../bupper-one-click/HOC"));

var TallymanClick2sms_V1 = _interopRequireWildcard(require("../tallyman.v1-click2sms/HOC"));

var _tryGetIPRangeName = _interopRequireDefault(require("../../ips/tryGetIPRangeName"));

var _record = _interopRequireDefault(require("../../pacman/record"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var initialState = {
  type: "LOADING",
  result: RDS.NothingYet()
}; // export interface IActions {
//   submitMSISDN: (window: Window, config: IConfig, msisdn: string, operator:string, extraParams?: IHash) => any,
//   backToStart: () => void
// }

exports.initialState = initialState;

function strategy(_ref) {
  var operatorSelect = _ref.operatorSelect,
      msisdnEntry = _ref.msisdnEntry,
      pinEntry = _ref.pinEntry,
      mo = _ref.mo,
      oneClick = _ref.oneClick,
      click2sms = _ref.click2sms,
      moRedir = _ref.moRedir,
      loading = _ref.loading;
  return function (state) {
    switch (state.type) {
      case 'OPERATORSelect':
        return operatorSelect(state.result);

      case 'MSISDNEntry':
        return msisdnEntry(state.result);

      case 'PIN':
        return pinEntry(state.result);

      case 'MO':
        return mo(state.result);

      case 'ONECLICK':
        return oneClick(state.result);

      case 'CLICK2SMS':
        return click2sms(state.result);

      case 'MOREDIR':
        return moRedir(state.result);

      case 'LOADING':
        return loading(state.result);
    }
  };
}

var isMSISDNEntry = function isMSISDNEntry(s) {
  return s.type == "MSISDNEntry";
};

exports.isMSISDNEntry = isMSISDNEntry;

var isPINFlow = function isPINFlow(s) {
  return s.type == "PIN";
};

exports.isPINFlow = isPINFlow;

var isMOFlow = function isMOFlow(s) {
  return s.type == "MO";
};

exports.isMOFlow = isMOFlow;

var isOneClickFlow = function isOneClickFlow(s) {
  return s.type == "ONECLICK";
};

exports.isOneClickFlow = isOneClickFlow;

var isClic2SmsFlow = function isClic2SmsFlow(s) {
  return s.type == "CLICK2SMS";
};

exports.isClic2SmsFlow = isClic2SmsFlow;

var isMoRedirFlow = function isMoRedirFlow(s) {
  return s.type == "MOREDIR";
};

exports.isMoRedirFlow = isMoRedirFlow;

var isTopLoading = function isTopLoading(s) {
  return s.type == "LOADING";
};

exports.isTopLoading = isTopLoading;

var getConfig = function getConfig() {
  try {
    var _configs = require("../../../../../config.json");

    return _configs;
  } catch (ex) {
    throw "config.json not found";
  }
};

var configs = getConfig();
var defaultFlowConfig = configs.strategyConfigs.default;
var operatorsConfig = configs.strategyConfigs.operators;

function determineFlowByMsidn(_x) {
  return _determineFlowByMsidn.apply(this, arguments);
}

function _determineFlowByMsidn() {
  _determineFlowByMsidn = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(internationalMSISDN) {
    var submissionError, msisdn, indentifyFlow, theResult, flow, cannotDetect, hlrError, _submissionError, flowObj, _flowObj, _submissionError2;

    return regeneratorRuntime.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            if (internationalMSISDN) {
              _context8.next = 4;
              break;
            }

            submissionError = new Error("Error in submitMSISDN() trigger-pin action");
            submissionError['type'] = "SEInvalidMSISDN";
            throw submissionError;

          case 4:
            msisdn = internationalMSISDN.match(/\d+/gi).join(''); // tallyman API expects international msisdn without any special character

            _context8.prev = 5;

            indentifyFlow = /*#__PURE__*/function () {
              var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
                var config, slug, country, device, host, rockmanId, offer, flowOperatorResult;
                return regeneratorRuntime.wrap(function _callee7$(_context7) {
                  while (1) {
                    switch (_context7.prev = _context7.next) {
                      case 0:
                        config = defaultFlowConfig.flowConfig;
                        slug = config.slug, country = config.country, device = config.device, host = config.host;
                        rockmanId = window.pac_analytics.visitor.rockmanId;
                        offer = window.pac_analytics.visitor.offer;
                        _context7.next = 6;
                        return fetch("https://".concat(host, "/tallyman/v1/?action=identify&slug=").concat(slug, "&country=").concat(country, "&msisdn=").concat(msisdn, "&device=").concat(device, "&offerId=").concat(offer, "&rockman_id=").concat(rockmanId)).then(function (x) {
                          return x.json();
                        });

                      case 6:
                        flowOperatorResult = _context7.sent;
                        return _context7.abrupt("return", flowOperatorResult);

                      case 8:
                      case "end":
                        return _context7.stop();
                    }
                  }
                }, _callee7);
              }));

              return function indentifyFlow() {
                return _ref7.apply(this, arguments);
              };
            }();

            _context8.next = 9;
            return indentifyFlow();

          case 9:
            theResult = _context8.sent;
            flow = operatorsConfig[theResult.operator] ? operatorsConfig[theResult.operator] : null;
            cannotDetect = theResult.success === false && theResult.message === "Operator could not be found for the given MSISDN";
            hlrError = theResult.success === false && theResult.message.indexOf("HLR did not find the operator for given MSISDN") !== -1;

            if (!(cannotDetect || hlrError)) {
              _context8.next = 20;
              break;
            }

            _submissionError = new Error("Error in submitMSISDN() identify flow");
            _submissionError['type'] = "FlowDetectFailed";
            _submissionError['msisdn'] = msisdn;
            throw _submissionError;

          case 20:
            if (!(flow !== null)) {
              _context8.next = 25;
              break;
            }

            flowObj = _objectSpread({
              operator: theResult.operator,
              default: defaultFlowConfig
            }, flow);
            return _context8.abrupt("return", flowObj);

          case 25:
            if (!(flow === null)) {
              _context8.next = 30;
              break;
            }

            _flowObj = _objectSpread({
              operator: theResult.operator
            }, defaultFlowConfig);
            return _context8.abrupt("return", _flowObj);

          case 30:
            _submissionError2 = new Error("Error in submitMSISDN() trigger-pin action");
            _submissionError2['type'] = "SEInvalidMSISDN";
            throw _submissionError2;

          case 33:
            _context8.next = 38;
            break;

          case 35:
            _context8.prev = 35;
            _context8.t0 = _context8["catch"](5);
            throw _context8.t0;

          case 38:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8, null, [[5, 35]]);
  }));
  return _determineFlowByMsidn.apply(this, arguments);
}

function determineFlowByOperator(operator) {
  var flowObj = _objectSpread({
    operator: operator,
    default: defaultFlowConfig
  }, operatorsConfig[operator]);

  return flowObj;
} //if operator from server
//no need for this


function getOperators() {
  return _getOperators.apply(this, arguments);
} //FLOWS
//pin flow


function _getOperators() {
  _getOperators = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
    var operators;
    return regeneratorRuntime.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            operators = Object.keys(operatorsConfig);
            return _context9.abrupt("return", operators);

          case 2:
          case "end":
            return _context9.stop();
        }
      }
    }, _callee9);
  }));
  return _getOperators.apply(this, arguments);
}

var pinFlow = function pinFlow(tracker, config, msisdn, extraParams) {
  var result = function result(Component) {
    var HOC = TallymanPin_V1.default;

    var Wrapper = function Wrapper(_ref2) {
      var currentState = _ref2.currentState,
          actions = _ref2.actions,
          strategyConfig = _ref2.strategyConfig;

      if (!!msisdn) {
        React.useEffect(function () {
          actions.submitMSISDN(window, null, msisdn, null, extraParams);
        }, []);
      }

      return /*#__PURE__*/React.createElement(Component, {
        currentState: currentState,
        actions: actions,
        strategyConfig: strategyConfig
      });
    };

    var C = HOC(tracker, Wrapper, config)(TallymanPin_V1.initialState);
    return /*#__PURE__*/React.createElement(C, null);
  };

  return result;
}; //mo flow


var moFlow = function moFlow(tracker, config, msisdn) {
  var result = function result(Component) {
    var HOC = TallymanMo_V1.default;

    var Wrapper = function Wrapper(_ref3) {
      var currentState = _ref3.currentState,
          actions = _ref3.actions,
          strategyConfig = _ref3.strategyConfig;

      if (!!msisdn) {
        React.useEffect(function () {
          actions.submitMSISDN(window, null, msisdn);
        }, []);
      }

      return /*#__PURE__*/React.createElement(Component, {
        currentState: currentState,
        actions: actions,
        strategyConfig: strategyConfig
      });
    };

    var C = HOC(tracker, Wrapper, config)(TallymanMo_V1.initialState);
    return /*#__PURE__*/React.createElement(C, null);
  };

  return result;
}; //One Click flow


var oneClickFlow = function oneClickFlow(tracker, config, extraParams) {
  var result = function result(Component) {
    var HOC = BupperOneClick.default;

    var Wrapper = function Wrapper(_ref4) {
      var currentState = _ref4.currentState,
          actions = _ref4.actions,
          strategyConfig = _ref4.strategyConfig;
      return /*#__PURE__*/React.createElement(Component, {
        actions: actions,
        currentState: currentState,
        ClickLink: actions.clickLink,
        strategyConfig: strategyConfig
      });
    };

    var C = HOC(tracker, null, Wrapper, extraParams, config)(BupperOneClick.initialState);
    return /*#__PURE__*/React.createElement(C, null);
  };

  return result;
}; //Click 2sms flow


var click2smsFlow = function click2smsFlow(tracker, config) {
  var result = function result(Component) {
    var HOC = TallymanClick2sms_V1.default;

    var Wrapper = function Wrapper(_ref5) {
      var currentState = _ref5.currentState,
          actions = _ref5.actions,
          MOLink = _ref5.MOLink,
          strategyConfig = _ref5.strategyConfig;
      return /*#__PURE__*/React.createElement(Component, {
        actions: actions,
        currentState: currentState,
        MOLink: actions.moLink,
        strategyConfig: strategyConfig
      });
    };

    var C = HOC(tracker, Wrapper, null, config)(TallymanClick2sms_V1.initialState);
    return /*#__PURE__*/React.createElement(C, null);
  };

  return result;
}; //moRedir flow


var moRedirFlow = function moRedirFlow(tracker, config, msisdn, bupperNumber) {
  var result = function result(Component) {
    var HOC = TallymanMoRedir_V1.default;

    var Wrapper = function Wrapper(_ref6) {
      var currentState = _ref6.currentState,
          actions = _ref6.actions,
          strategyConfig = _ref6.strategyConfig;
      console.log("msisdn", msisdn);
      console.log("bupperNumber", bupperNumber);

      if (!!msisdn && !!bupperNumber) {
        React.useEffect(function () {
          actions.submitMSISDN(window, null, msisdn, bupperNumber);
        }, []);
      }

      return /*#__PURE__*/React.createElement(Component, {
        currentState: currentState,
        actions: actions,
        strategyConfig: strategyConfig
      });
    };

    var C = HOC(tracker, Wrapper, config)(TallymanMoRedir_V1.initialState); //@ts-ignore

    return /*#__PURE__*/React.createElement(C, null);
  };

  return result;
};

function mockConfig(flow) {
  var opArr = Object.keys(operatorsConfig);
  var r = opArr.filter(function (o) {
    return operatorsConfig[o].flow === flow;
  });
  var operator = r[0];

  var flowObj = _objectSpread({
    operator: operator,
    default: defaultFlowConfig
  }, operatorsConfig[operator]);

  return flowObj;
}

var mockTracker = (0, _record.default)(typeof window != "undefined" ? window : null, "xx", "demo-strategy");
var mockedPinFlow = {
  type: "PIN",
  result: pinFlow(mockTracker, mockConfig("pin"))
};
exports.mockedPinFlow = mockedPinFlow;
var mockedMOFlow = {
  type: "MO",
  result: moFlow(mockTracker, mockConfig("mo"))
};
exports.mockedMOFlow = mockedMOFlow;
var mockedOneClickFlow = {
  type: "ONECLICK",
  result: oneClickFlow(mockTracker, mockConfig("oneClick"), {
    "testextraparams": "1"
  })
};
exports.mockedOneClickFlow = mockedOneClickFlow;
var mockedClick2smsFlow = {
  type: "CLICK2SMS",
  result: click2smsFlow(mockTracker, mockConfig("click2sms"))
};
exports.mockedClick2smsFlow = mockedClick2smsFlow;
var mockedMORedirFlow = {
  type: "MOREDIR",
  result: moRedirFlow(mockTracker, mockConfig("moRedir"))
}; //export const mockedCompletedState : State = { type: "Completed", result: {finalUrl: 'https://www.yahoo.com/'} }

exports.mockedMORedirFlow = mockedMORedirFlow;

var _default = function _default(tracker, Comp, extraStrategyParams) {
  return function (initialState, isMocked) {
    var _temp;

    var HOC = (_temp = /*#__PURE__*/function (_React$PureComponent) {
      _inherits(HOC, _React$PureComponent);

      var _super = _createSuper(HOC);

      function HOC(props) {
        var _this;

        _classCallCheck(this, HOC);

        _this = _super.call(this, props);

        _defineProperty(_assertThisInitialized(_this), "state", void 0);

        var self = _assertThisInitialized(_this);

        _this.state = {
          currentState: initialState,
          actions: {
            backToStart: function backToStart() {
              _this.setState({
                currentState: initialState
              });
            },
            selectOperator: function selectOperator(operator, phoneNumber, extraParams) {
              //@ts-ignore
              var msisdn = phoneNumber;

              try {
                var flowObj = determineFlowByOperator(operator);
                self.setState({
                  strategyConfig: flowObj
                });

                switch (flowObj.flow) {
                  case "pin":
                    self.setState({
                      currentState: {
                        type: "PIN",
                        result: pinFlow(tracker, flowObj, msisdn, extraParams)
                      }
                    });
                    tracker.advancedInFlow('tallyman/v1', 'pin-flow', {
                      operator: operator
                    });
                    break;

                  case "mo":
                    self.setState({
                      currentState: {
                        type: "MO",
                        result: moFlow(tracker, flowObj, msisdn)
                      }
                    });
                    tracker.advancedInFlow('tallyman/v1', 'mo-flow', {
                      operator: operator
                    });
                    break;

                  case "oneClick":
                    self.setState({
                      currentState: {
                        type: "ONECLICK",
                        result: oneClickFlow(tracker, flowObj, !!extraStrategyParams && !!extraStrategyParams["oneClick"] ? extraStrategyParams["oneClick"] : null)
                      }
                    });
                    tracker.advancedInFlow('bupper', 'oneClick-flow', {
                      operator: operator
                    });
                    break;

                  case "click2sms":
                    self.setState({
                      currentState: {
                        type: "CLICK2SMS",
                        result: click2smsFlow(tracker, flowObj)
                      }
                    });
                    tracker.advancedInFlow('bupper', 'click2sms-flow', {
                      operator: operator
                    });
                    break;

                  default:
                    self.setState({
                      currentState: {
                        type: "PIN",
                        result: pinFlow(tracker, flowObj, msisdn, extraParams)
                      }
                    });
                    tracker.advancedInFlow('tallyman/v1', 'pin-flow', {
                      operator: operator
                    });
                    break;
                }
              } catch (ex) {}
            },
            submitMSISDN: function () {
              var _submitMSISDN = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                var _len,
                    args,
                    _key,
                    msisdn,
                    extraParams,
                    bupperNumber,
                    pinMoAskMobileNumber,
                    pinMoRedirAskMobileNumber,
                    pinClick2SmsAskMobileNumber,
                    click2SmsMoAskMobileNumber,
                    flowObjByMsisdn,
                    flowObj,
                    errorType,
                    operators,
                    _args = arguments;

                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _this.setState({
                          currentState: {
                            type: "MSISDNEntry",
                            result: RDS.Loading()
                          }
                        });

                        for (_len = _args.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
                          args[_key] = _args[_key];
                        }

                        msisdn = args[2], extraParams = args[4], bupperNumber = args[5]; //MSISDN: strategies

                        pinMoAskMobileNumber = function pinMoAskMobileNumber(flowObj) {
                          switch (flowObj.flow) {
                            case "pin":
                              self.setState({
                                currentState: {
                                  type: "PIN",
                                  result: pinFlow(tracker, flowObj, msisdn, extraParams)
                                }
                              });
                              tracker.advancedInFlow('tallyman/v1', 'pin-flow', {
                                msisdn: msisdn
                              });
                              break;

                            case "mo":
                              self.setState({
                                currentState: {
                                  type: "MO",
                                  result: moFlow(tracker, flowObj, msisdn)
                                }
                              });
                              tracker.advancedInFlow('tallyman/v1', 'mo-flow', {
                                msisdn: msisdn
                              });
                              break;

                            default:
                              self.setState({
                                currentState: {
                                  type: flowObj.default.flow.toUpperCase(),
                                  result: pinFlow(tracker, flowObj.default, msisdn, extraParams)
                                }
                              });
                              tracker.advancedInFlow('tallyman/v1', 'pin-flow', {
                                msisdn: msisdn
                              });
                              break;
                          }
                        };

                        pinMoRedirAskMobileNumber = function pinMoRedirAskMobileNumber(flowObj) {
                          switch (flowObj.flow) {
                            case "pin":
                              self.setState({
                                currentState: {
                                  type: "PIN",
                                  result: pinFlow(tracker, flowObj, msisdn, extraParams)
                                }
                              });
                              tracker.advancedInFlow('tallyman/v1', 'pin-flow', {
                                msisdn: msisdn
                              });
                              break;

                            case "moRedir":
                              self.setState({
                                currentState: {
                                  type: "MOREDIR",
                                  result: moRedirFlow(tracker, flowObj, msisdn, bupperNumber)
                                }
                              });
                              tracker.advancedInFlow('tallyman/v1', 'moRedir-flow', {
                                msisdn: msisdn
                              });
                              break;

                            default:
                              self.setState({
                                currentState: {
                                  type: flowObj.default.flow.toUpperCase(),
                                  result: pinFlow(tracker, flowObj.default, msisdn, extraParams)
                                }
                              });
                              tracker.advancedInFlow('tallyman/v1', 'pin-flow', {
                                msisdn: msisdn
                              });
                              break;
                          }
                        };

                        pinClick2SmsAskMobileNumber = function pinClick2SmsAskMobileNumber(flowObj) {
                          switch (flowObj.flow) {
                            case "pin":
                              self.setState({
                                currentState: {
                                  type: "PIN",
                                  result: pinFlow(tracker, flowObj, msisdn, extraParams)
                                }
                              });
                              tracker.advancedInFlow('tallyman/v1', 'pin-flow', {
                                msisdn: msisdn
                              });
                              break;

                            case "click2sms":
                              self.setState({
                                currentState: {
                                  type: "CLICK2SMS",
                                  result: click2smsFlow(tracker, flowObj)
                                }
                              });
                              tracker.advancedInFlow('tallyman/v1', 'click2sms-flow', {
                                msisdn: msisdn
                              });
                              break;

                            default:
                              self.setState({
                                currentState: {
                                  type: flowObj.default.flow.toUpperCase(),
                                  result: pinFlow(tracker, flowObj.default, msisdn, extraParams)
                                }
                              });
                              tracker.advancedInFlow('tallyman/v1', 'pin-flow', {
                                msisdn: msisdn
                              });
                              break;
                          }
                        };

                        click2SmsMoAskMobileNumber = function click2SmsMoAskMobileNumber(flowObj) {
                          switch (flowObj.flow) {
                            case "mo":
                              self.setState({
                                currentState: {
                                  type: "MO",
                                  result: moFlow(tracker, flowObj, msisdn)
                                }
                              });
                              tracker.advancedInFlow('tallyman/v1', 'mo-flow', {
                                msisdn: msisdn
                              });
                              break;

                            case "click2sms":
                              self.setState({
                                currentState: {
                                  type: "CLICK2SMS",
                                  result: click2smsFlow(tracker, flowObj)
                                }
                              });
                              tracker.advancedInFlow('tallyman/v1', 'click2sms-flow', {
                                msisdn: msisdn
                              });
                              break;

                            default:
                              self.setState({
                                currentState: {
                                  type: flowObj.default.flow.toUpperCase(),
                                  result: click2smsFlow(tracker, flowObj.default)
                                }
                              });
                              tracker.advancedInFlow('tallyman/v1', 'click2sms-flow', {
                                msisdn: msisdn
                              });
                              break;
                          }
                        };

                        _context.prev = 7;
                        _context.next = 10;
                        return determineFlowByMsidn(msisdn);

                      case 10:
                        flowObjByMsisdn = _context.sent;
                        flowObj = operatorsConfig[flowObjByMsisdn.operator] ? flowObjByMsisdn : _objectSpread({
                          operator: flowObjByMsisdn.operator
                        }, defaultFlowConfig);
                        self.setState({
                          strategyConfig: flowObj
                        }); //Switch on strategies based on phone number 

                        _context.t0 = configs.strategy;
                        _context.next = _context.t0 === "pin-mo-ask-mobile-number" ? 16 : _context.t0 === "pin-mo-redir-ask-mobile-number" ? 18 : _context.t0 === "pin-click2sms-ask-mobile-number" ? 20 : _context.t0 === "click2sms-mo-ask-mobile-number" ? 22 : 24;
                        break;

                      case 16:
                        pinMoAskMobileNumber(flowObj);
                        return _context.abrupt("break", 26);

                      case 18:
                        pinMoRedirAskMobileNumber(flowObj);
                        return _context.abrupt("break", 26);

                      case 20:
                        pinClick2SmsAskMobileNumber(flowObj);
                        return _context.abrupt("break", 26);

                      case 22:
                        click2SmsMoAskMobileNumber(flowObj);
                        return _context.abrupt("break", 26);

                      case 24:
                        pinMoAskMobileNumber(flowObj);
                        return _context.abrupt("break", 26);

                      case 26:
                        _context.next = 41;
                        break;

                      case 28:
                        _context.prev = 28;
                        _context.t1 = _context["catch"](7);
                        errorType = "SEAlreadySubscribed" === _context.t1.type ? "AlreadySubscribed" : "SEInvalidMSISDN" == _context.t1.type ? "InvalidMSISDN" : "UnknownError";

                        if (!(_context.t1.type === "FlowDetectFailed")) {
                          _context.next = 39;
                          break;
                        }

                        _context.next = 34;
                        return getOperators();

                      case 34:
                        operators = _context.sent;

                        if (operators.length === 1) {
                          _this.setState({
                            currentState: {
                              type: defaultFlowConfig.flow.toUpperCase(),
                              result: pinFlow(tracker, defaultFlowConfig)
                            }
                          });
                        } else {
                          _this.setState({
                            currentState: {
                              type: "OPERATORSelect",
                              result: RDS.Success({
                                operators: operators,
                                msisdn: _context.t1.msisdn
                              })
                            }
                          });
                        }

                        tracker.recedeInFlow('assrock/v1', 'msisdn-flow-detection-failure', {
                          msisdn: msisdn,
                          errorType: errorType || 'UnknownError'
                        });
                        _context.next = 41;
                        break;

                      case 39:
                        self.setState({
                          currentState: {
                            type: "MSISDNEntry",
                            result: RDS.Failure({
                              errorType: errorType,
                              error: _context.t1
                            })
                          }
                        });
                        tracker.recedeInFlow('assrock/v1', 'msisdn-submission-failure', {
                          msisdn: msisdn,
                          errorType: errorType || 'UnknownError'
                        });

                      case 41:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee, null, [[7, 28]]);
              }));

              function submitMSISDN() {
                return _submitMSISDN.apply(this, arguments);
              }

              return submitMSISDN;
            }()
          }
        };
        return _this;
      } //mo-redir-one-click-detect-operator-by-ip


      _createClass(HOC, [{
        key: "moRedirOneClickDetectOperatorByIp",
        value: function () {
          var _moRedirOneClickDetectOperatorByIp = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
            var operator, flowObj;
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    if (!(typeof window != "undefined")) {
                      _context2.next = 25;
                      break;
                    }

                    _context2.prev = 1;
                    _context2.next = 4;
                    return (0, _tryGetIPRangeName.default)(window.pac_analytics.visitor);

                  case 4:
                    operator = _context2.sent;
                    flowObj = determineFlowByOperator(operator ? operator.toUpperCase() : "");
                    this.setState({
                      strategyConfig: flowObj
                    });

                    if (!(operator !== null && flowObj.hasOwnProperty("flow"))) {
                      _context2.next = 18;
                      break;
                    }

                    _context2.t0 = flowObj.flow.toUpperCase();
                    _context2.next = _context2.t0 === "ONECLICK" ? 11 : _context2.t0 === "MOREDIR" ? 13 : 14;
                    break;

                  case 11:
                    this.setState({
                      currentState: {
                        type: "ONECLICK",
                        result: oneClickFlow(tracker, flowObj, !!extraStrategyParams && !!extraStrategyParams["oneClick"] ? extraStrategyParams["oneClick"] : null)
                      }
                    });
                    return _context2.abrupt("break", 16);

                  case 13:
                    this.setState({
                      currentState: {
                        type: "MOREDIR",
                        result: moRedirFlow(tracker, flowObj)
                      }
                    });

                  case 14:
                    this.setState({
                      currentState: {
                        type: defaultFlowConfig.flow.toUpperCase(),
                        result: moRedirFlow(tracker, defaultFlowConfig)
                      }
                    });
                    return _context2.abrupt("break", 16);

                  case 16:
                    _context2.next = 19;
                    break;

                  case 18:
                    this.setState({
                      currentState: {
                        type: defaultFlowConfig.flow.toUpperCase(),
                        result: moRedirFlow(tracker, defaultFlowConfig)
                      }
                    });

                  case 19:
                    _context2.next = 25;
                    break;

                  case 21:
                    _context2.prev = 21;
                    _context2.t1 = _context2["catch"](1);
                    this.setState({
                      currentState: {
                        type: defaultFlowConfig.flow.toUpperCase(),
                        result: moRedirFlow(tracker, defaultFlowConfig)
                      }
                    });
                    throw _context2.t1;

                  case 25:
                  case "end":
                    return _context2.stop();
                }
              }
            }, _callee2, this, [[1, 21]]);
          }));

          function moRedirOneClickDetectOperatorByIp() {
            return _moRedirOneClickDetectOperatorByIp.apply(this, arguments);
          }

          return moRedirOneClickDetectOperatorByIp;
        }()
      }, {
        key: "pinOneClickDetectOperatorByIp",
        value: function () {
          var _pinOneClickDetectOperatorByIp = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
            var operator, flowObj;
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    if (!(typeof window != "undefined")) {
                      _context3.next = 25;
                      break;
                    }

                    _context3.prev = 1;
                    _context3.next = 4;
                    return (0, _tryGetIPRangeName.default)(window.pac_analytics.visitor);

                  case 4:
                    operator = _context3.sent;
                    flowObj = determineFlowByOperator(operator ? operator.toUpperCase() : "");
                    this.setState({
                      strategyConfig: flowObj
                    });

                    if (!(operator !== null && flowObj.hasOwnProperty("flow"))) {
                      _context3.next = 18;
                      break;
                    }

                    _context3.t0 = flowObj.flow.toUpperCase();
                    _context3.next = _context3.t0 === "ONECLICK" ? 11 : _context3.t0 === "PIN" ? 13 : 14;
                    break;

                  case 11:
                    this.setState({
                      currentState: {
                        type: "ONECLICK",
                        result: oneClickFlow(tracker, flowObj, !!extraStrategyParams && !!extraStrategyParams["oneClick"] ? extraStrategyParams["oneClick"] : null)
                      }
                    });
                    return _context3.abrupt("break", 16);

                  case 13:
                    this.setState({
                      currentState: {
                        type: "PIN",
                        result: pinFlow(tracker, flowObj)
                      }
                    });

                  case 14:
                    this.setState({
                      currentState: {
                        type: defaultFlowConfig.flow.toUpperCase(),
                        result: pinFlow(tracker, defaultFlowConfig)
                      }
                    });
                    return _context3.abrupt("break", 16);

                  case 16:
                    _context3.next = 19;
                    break;

                  case 18:
                    this.setState({
                      currentState: {
                        type: defaultFlowConfig.flow.toUpperCase(),
                        result: pinFlow(tracker, defaultFlowConfig)
                      }
                    });

                  case 19:
                    _context3.next = 25;
                    break;

                  case 21:
                    _context3.prev = 21;
                    _context3.t1 = _context3["catch"](1);
                    this.setState({
                      currentState: {
                        type: defaultFlowConfig.flow.toUpperCase(),
                        result: pinFlow(tracker, defaultFlowConfig)
                      }
                    });
                    throw _context3.t1;

                  case 25:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _callee3, this, [[1, 21]]);
          }));

          function pinOneClickDetectOperatorByIp() {
            return _pinOneClickDetectOperatorByIp.apply(this, arguments);
          }

          return pinOneClickDetectOperatorByIp;
        }()
      }, {
        key: "pinOneClickMoDetectOperatorByIpOrMsisdn",
        value: function () {
          var _pinOneClickMoDetectOperatorByIpOrMsisdn = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
            var operator, flowObj;
            return regeneratorRuntime.wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    if (!(typeof window != "undefined")) {
                      _context4.next = 26;
                      break;
                    }

                    _context4.prev = 1;
                    _context4.next = 4;
                    return (0, _tryGetIPRangeName.default)(window.pac_analytics.visitor);

                  case 4:
                    operator = _context4.sent;
                    flowObj = determineFlowByOperator(operator ? operator.toUpperCase() : "");
                    this.setState({
                      strategyConfig: flowObj
                    });

                    if (!(operator !== null && flowObj.hasOwnProperty("flow"))) {
                      _context4.next = 19;
                      break;
                    }

                    _context4.t0 = flowObj.flow.toUpperCase();
                    _context4.next = _context4.t0 === "ONECLICK" ? 11 : _context4.t0 === "MO" ? 13 : 15;
                    break;

                  case 11:
                    this.setState({
                      currentState: {
                        type: "ONECLICK",
                        result: oneClickFlow(tracker, flowObj, !!extraStrategyParams && !!extraStrategyParams["oneClick"] ? extraStrategyParams["oneClick"] : null)
                      }
                    });
                    return _context4.abrupt("break", 17);

                  case 13:
                    this.setState({
                      currentState: {
                        type: "MO",
                        result: moFlow(tracker, flowObj)
                      }
                    });
                    return _context4.abrupt("break", 17);

                  case 15:
                    this.setState({
                      currentState: {
                        type: "MSISDNEntry",
                        result: RDS.NothingYet()
                      }
                    });
                    return _context4.abrupt("break", 17);

                  case 17:
                    _context4.next = 20;
                    break;

                  case 19:
                    this.setState({
                      currentState: {
                        type: "MSISDNEntry",
                        result: RDS.NothingYet()
                      }
                    });

                  case 20:
                    _context4.next = 26;
                    break;

                  case 22:
                    _context4.prev = 22;
                    _context4.t1 = _context4["catch"](1);
                    this.setState({
                      currentState: {
                        type: "MSISDNEntry",
                        result: RDS.NothingYet()
                      }
                    });
                    throw _context4.t1;

                  case 26:
                  case "end":
                    return _context4.stop();
                }
              }
            }, _callee4, this, [[1, 22]]);
          }));

          function pinOneClickMoDetectOperatorByIpOrMsisdn() {
            return _pinOneClickMoDetectOperatorByIpOrMsisdn.apply(this, arguments);
          }

          return pinOneClickMoDetectOperatorByIpOrMsisdn;
        }()
      }, {
        key: "askOperator",
        value: function () {
          var _askOperator = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
            var operators;
            return regeneratorRuntime.wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    _context5.next = 2;
                    return getOperators();

                  case 2:
                    operators = _context5.sent;

                    if (operators.length === 1) {
                      this.state.actions.selectOperator(operators[0]);
                    } else {
                      this.setState({
                        currentState: {
                          type: "OPERATORSelect",
                          result: RDS.Success({
                            operators: operators
                          })
                        }
                      });
                    }

                  case 4:
                  case "end":
                    return _context5.stop();
                }
              }
            }, _callee5, this);
          }));

          function askOperator() {
            return _askOperator.apply(this, arguments);
          }

          return askOperator;
        }()
      }, {
        key: "componentWillMount",
        value: function () {
          var _componentWillMount = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
            return regeneratorRuntime.wrap(function _callee6$(_context6) {
              while (1) {
                switch (_context6.prev = _context6.next) {
                  case 0:
                    if (isMocked) {
                      _context6.next = 26;
                      break;
                    }

                    _context6.t0 = configs.strategy;
                    _context6.next = _context6.t0 === "pin-mo-ask-operator" ? 4 : _context6.t0 === "pin-click2sms-ask-operator" ? 6 : _context6.t0 === "pin-click2sms-mo-ask-operator" ? 8 : _context6.t0 === "click2sms-mo-ask-operator" ? 10 : _context6.t0 === "pin-mo-ask-mobile-number" ? 12 : _context6.t0 === "pin-mo-redir-ask-mobile-number" ? 14 : _context6.t0 === "pin-one-click-detect-operator-by-ip" ? 16 : _context6.t0 === "one-click-mo-pin-detect-operator-by-ip-or-msisdn" ? 18 : _context6.t0 === "mo-redir-one-click-detect-operator-by-ip" ? 20 : _context6.t0 === "pin-click2sms-ask-mobile-number" ? 22 : _context6.t0 === "click2sms-mo-ask-mobile-number" ? 24 : 26;
                    break;

                  case 4:
                    this.askOperator();
                    return _context6.abrupt("break", 26);

                  case 6:
                    this.askOperator();
                    return _context6.abrupt("break", 26);

                  case 8:
                    this.askOperator();
                    return _context6.abrupt("break", 26);

                  case 10:
                    this.askOperator();
                    return _context6.abrupt("break", 26);

                  case 12:
                    this.setState({
                      currentState: {
                        type: "MSISDNEntry",
                        result: RDS.NothingYet()
                      }
                    });
                    return _context6.abrupt("break", 26);

                  case 14:
                    this.setState({
                      currentState: {
                        type: "MSISDNEntry",
                        result: RDS.NothingYet()
                      }
                    });
                    return _context6.abrupt("break", 26);

                  case 16:
                    this.pinOneClickDetectOperatorByIp();
                    return _context6.abrupt("break", 26);

                  case 18:
                    this.pinOneClickMoDetectOperatorByIpOrMsisdn();
                    return _context6.abrupt("break", 26);

                  case 20:
                    this.moRedirOneClickDetectOperatorByIp();
                    return _context6.abrupt("break", 26);

                  case 22:
                    this.setState({
                      currentState: {
                        type: "MSISDNEntry",
                        result: RDS.NothingYet()
                      }
                    });
                    return _context6.abrupt("break", 26);

                  case 24:
                    this.setState({
                      currentState: {
                        type: "MSISDNEntry",
                        result: RDS.NothingYet()
                      }
                    });
                    return _context6.abrupt("break", 26);

                  case 26:
                  case "end":
                    return _context6.stop();
                }
              }
            }, _callee6, this);
          }));

          function componentWillMount() {
            return _componentWillMount.apply(this, arguments);
          }

          return componentWillMount;
        }()
      }, {
        key: "render",
        value: function render() {
          return /*#__PURE__*/React.createElement(Comp, _extends({}, this.props, {
            currentState: this.state.currentState,
            actions: this.state.actions
          }));
        }
      }]);

      return HOC;
    }(React.PureComponent), _temp);
    HOC.prototype['_client'] = "super-strategy";
    return HOC;
  };
};

exports.default = _default;