import * as React from "react";
import { IConfig, ILinkExtraParams } from "./main";
import * as RDS from "../../common-types/RemoteDataState";
import { ITracker } from "../../pacman/record";
import { IFlow } from "../super-strategy/HOC";
export declare const Link: React.ComponentType<{
    href: string;
    children: React.ReactNode;
} & React.HTMLAttributes<HTMLAnchorElement>>;
export declare type MSISDNEntryFailure = {
    errorType: MSISDNEntryErrorTypes;
    error: any;
};
export declare type MSISDNEntrySuccess = {
    Link: ACompType;
    href: string;
};
declare type ACompType = React.ComponentType<{
    children: React.ReactNode;
} & React.HTMLAttributes<HTMLAnchorElement>>;
export declare type IdentifyUserErrorTypes = "NotOn3g" | "UnknownError";
export declare type SubscribeUserErrorTypes = "SubscriptionError" | "UnknownError";
export declare type IdentifyFailure = {
    errorType: IdentifyUserErrorTypes;
    error: Error;
};
export declare type IdentifySuccess = {
    Link: ACompType;
    href: string;
};
export declare type SubscribeSuccess = {
    product_url: string;
};
export declare type SubscribeFailure = {
    errorType: SubscribeUserErrorTypes;
    error: Error;
};
export declare type IState = {
    type: "IDENTIFY";
    result: RDS.RemoteDataState<IdentifyFailure, IdentifySuccess>;
} | {
    type: "MSISDNEntry";
    result: RDS.RemoteDataState<MSISDNEntryFailure, MSISDNEntrySuccess & {
        Link: ACompType;
    }>;
};
export declare type MSISDNEntryErrorTypes = "AlreadySubscribed" | "UnknownError" | "InvalidMSISDN";
export declare type PINEntryErrorTypes = "UnknownError" | "TooEarly" | "InvalidPIN";
export declare const initialState: IState;
export declare const mockedMSISDNEntrySuccess: IState;
export declare const mockedMSISDNEntryFailure: IState;
export declare function matchMSISDNEntry<R>(m: RDS.IMatcher<MSISDNEntryFailure, MSISDNEntrySuccess & {
    Link: ACompType;
}, R>): (model: RDS.RemoteDataState<MSISDNEntryFailure, MSISDNEntrySuccess & {
    Link: ACompType;
}>) => R;
export interface IActions {
    submitMSISDN: (window: Window, config: IConfig, internationalMsisdn: string, bupperMsisdn: string, strategy?: IFlow) => void;
    backToStart: () => void;
    identifyAction: () => any;
}
export declare type HOCProps = {
    currentState: IState;
    actions: IActions;
    strategyConfig?: IFlow;
    ClickLink: ACompType;
};
export declare function match<R>({ identify, msisdnEntry }: {
    identify: (rds: RDS.RemoteDataState<IdentifyFailure, IdentifySuccess>) => R;
    msisdnEntry: (rds: RDS.RemoteDataState<MSISDNEntryFailure, MSISDNEntrySuccess>) => R;
}): (state: IState) => R;
declare const _default: <P extends HOCProps>(tracker: ITracker, maybeConfig: IConfig, Comp: React.ComponentType<P>, extraParams?: ILinkExtraParams, strategy?: IFlow) => (initialState: IState, isMocked?: boolean) => {
    new (props: any): {
        state: {
            currentState: IState;
            actions: IActions;
            redirectUrl: string;
        };
        UNSAFE_componentWillMount(): Promise<void>;
        render(): JSX.Element;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<P>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
        forceUpdate(callback?: () => void): void;
        readonly props: Readonly<P> & Readonly<{
            children?: React.ReactNode;
        }>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<P>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<P>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<P>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<P>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<P>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<P>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<P>, nextState: Readonly<{}>, nextContext: any): void;
    };
    contextType?: React.Context<any>;
};
export default _default;
