import { IFlow } from "../super-strategy/HOC";
export declare type IConfig = {
    offer?: number;
    slug?: string;
    country?: string;
    host?: string;
    device?: "smart" | "feature";
    queryString?: Array<[string, string]>;
};
export interface ILinkExtraParams {
    [key: string]: string;
}
export declare type INextAction = {
    flow: string;
    url: string;
    type: "get";
    show_msisdn_prompt: boolean;
    show_operator_list: boolean;
};
export declare type IIDentifyUserResult = {
    success: true;
    rockman_id: string;
    redirect_url: string;
} | {
    success: false;
    rockman_id: string;
    message: string;
    next_action: INextAction;
};
export declare type ISubscribeResult = {
    success: true;
    rockman_id: string;
    product_url: string;
} | {
    success: false;
    rockman_id: string;
    message: string;
};
export declare type IMSISDNSubmissionResult = {
    success: true;
    rockman_id: string;
    redirect_url?: string;
} | {
    success: false;
    rockman_id: string;
    message: string;
    redirect_url?: string;
};
export declare const additionalQueryString = "msisdnSubmitted=Y&legalCheckbox=Y&incentivizedCheckbox=Y&op_confirmCheckbox=N";
export default function submitMSISDN(window: Window, maybeConfig: IConfig, internationalMSISDN: string, bupperMSISDN: string, strategy?: IFlow, extraParams?: {
    [key: string]: string;
}): Promise<string>;
export declare function submitMSISDNWithConfig(window: Window, config: IConfig, internationalMSISDN: string, extraParams?: {
    [key: string]: string;
}): Promise<string>;
export declare const getRedirectUrl: (maybeConfig: IConfig, extraParams?: ILinkExtraParams, strategy?: IFlow) => Promise<string>;
