import { IFlow } from "../super-strategy/HOC";
export declare type IConfig = {
    offer: number;
    slug?: string;
    country?: string;
    host?: string;
    device?: "smart" | "feature";
};
export declare type IKeywordShortcode = {
    keyword: string;
    shortcode: string;
};
export declare type IMSISDNSubmissionResult = {
    success: true;
    rockman_id: string;
    keyword: string;
    shortcode: string;
} | {
    success: false;
    rockman_id: string;
    message: string;
};
export declare type ICheckSubscriptionResult = {
    success: false;
    rockman_id: string;
    message: string;
} | {
    success: true;
    msisdn: string;
    product_url?: string;
    rockman_id: string;
};
export default function submitMSISDN(window: Window, maybeConfig: IConfig, internationalMSISDN: string, strategy?: IFlow, extraParams?: {
    [key: string]: string;
}): Promise<IKeywordShortcode>;
export declare function submitMSISDNWithConfig(window: Window, config: IConfig, internationalMSISDN: string, extraParams?: {
    [key: string]: string;
}): Promise<IKeywordShortcode>;
export declare function checkSubscription(window: Window, maybeConfig: IConfig, internationalMSISDN: string, strategy?: IFlow, extraParams?: {
    [key: string]: string;
}): Promise<string>;
