"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = submitMSISDN;
exports.submitMSISDNWithConfig = submitMSISDNWithConfig;
exports.checkSubscription = checkSubscription;

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.regexp.match");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.regexp.search");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var getConfig = function getConfig() {
  try {
    var configs = require("../../../../../config.json");

    return configs;
  } catch (ex) {
    throw "config.json not found";
  }
};

function submitMSISDN(_x, _x2, _x3, _x4, _x5) {
  return _submitMSISDN.apply(this, arguments);
}

function _submitMSISDN() {
  _submitMSISDN = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(window, maybeConfig, internationalMSISDN, strategy, extraParams) {
    var config;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            config = strategy ? _objectSpread({
              offer: window.pac_analytics.visitor.offer
            }, strategy.flowConfig) : _objectSpread(_objectSpread({
              offer: window.pac_analytics.visitor.offer
            }, getConfig()), maybeConfig || {});
            return _context2.abrupt("return", submitMSISDNWithConfig(window, config, internationalMSISDN, extraParams));

          case 2:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _submitMSISDN.apply(this, arguments);
}

function submitMSISDNWithConfig(_x6, _x7, _x8, _x9) {
  return _submitMSISDNWithConfig.apply(this, arguments);
}

function _submitMSISDNWithConfig() {
  _submitMSISDNWithConfig = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(window, config, internationalMSISDN, extraParams) {
    var slug, country, device, offer, host, search, extraParamsQs, msisdn, rockmanId, result, type, error;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            slug = config.slug, country = config.country, device = config.device, offer = config.offer, host = config.host;
            search = window.location.search.substr(1) || '';
            extraParamsQs = !extraParams ? '' : '&' + Object.keys(extraParams).map(function (k) {
              return "".concat(k, "=").concat(extraParams[k]);
            }).join('&');
            msisdn = internationalMSISDN.match(/\d+/gi).join('');
            rockmanId = window.pac_analytics.visitor.rockmanId;
            _context3.next = 7;
            return fetch("https://".concat(host, "/tallyman/v1/?action=trigger-message&slug=").concat(slug, "&country=").concat(country, "&msisdn=").concat(msisdn, "&device=").concat(device, "&offerId=").concat(offer, "&rockman_id=").concat(rockmanId, "&").concat(search).concat(extraParamsQs)).then(function (x) {
              return x.json();
            });

          case 7:
            result = _context3.sent;

            if (!(false === result.success)) {
              _context3.next = 16;
              break;
            }

            type = result.message == 'ALREADY SUBSCRIBED' ? "AlreadySubscribed" : "InvalidMSISDN";
            error = new Error("".concat(type, ":\n").concat(result.message));
            error['type'] = type;
            console.error(error);
            throw error;

          case 16:
            return _context3.abrupt("return", result);

          case 17:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _submitMSISDNWithConfig.apply(this, arguments);
}

var wait = function wait(ms) {
  return new Promise(function (resolve) {
    return setTimeout(function () {
      return resolve();
    }, ms);
  });
};

var loop = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(f, max, stop, i) {
    var r;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return f();

          case 2:
            r = _context.sent;

            if (!(stop(r) || i >= max)) {
              _context.next = 7;
              break;
            }

            return _context.abrupt("return", r);

          case 7:
            _context.next = 9;
            return wait(10000);

          case 9:
            return _context.abrupt("return", loop(f, max, stop, i + 1));

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function loop(_x10, _x11, _x12, _x13) {
    return _ref.apply(this, arguments);
  };
}();

function checkSubscription(_x14, _x15, _x16, _x17, _x18) {
  return _checkSubscription.apply(this, arguments);
}

function _checkSubscription() {
  _checkSubscription = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(window, maybeConfig, internationalMSISDN, strategy, extraParams) {
    var config, host, rockmanId, check, checkResult, error;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            config = strategy ? _objectSpread({
              offer: window.pac_analytics.visitor.offer
            }, strategy.flowConfig) : _objectSpread(_objectSpread({
              offer: window.pac_analytics.visitor.offer
            }, getConfig()), maybeConfig || {});
            host = config.host;
            rockmanId = window.pac_analytics.visitor.rockmanId;

            check = function check() {
              return fetch("https://".concat(host, "/tallyman/v1/?action=check-subscription&rockman_id=").concat(rockmanId)).then(function (x) {
                return x.json();
              });
            };

            _context4.next = 6;
            return loop(check, 60, function (r) {
              return r.success;
            }, 0);

          case 6:
            checkResult = _context4.sent;

            if (!(true === checkResult.success)) {
              _context4.next = 12;
              break;
            }

            window.location.href = checkResult.product_url;
            return _context4.abrupt("return", checkResult.product_url || null);

          case 12:
            error = new Error("SubscriptionFailed".concat(":\n", checkResult.message));
            error['type'] = "SubscriptionFailed";
            throw error;

          case 15:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _checkSubscription.apply(this, arguments);
}