"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = submitMSISDN;
exports.submitMSISDNWithConfig = submitMSISDNWithConfig;
exports.additionalQueryString = void 0;

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.regexp.match");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.regexp.search");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

var _tryGetIPRangeName = _interopRequireDefault(require("../../ips/tryGetIPRangeName"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// &msisdn%5B0%5D=506541284
var additionalQueryString = "msisdnSubmitted=Y&legalCheckbox=Y&incentivizedCheckbox=Y&op_confirmCheckbox=N";
exports.additionalQueryString = additionalQueryString;

var getConfig = function getConfig() {
  try {
    var configs = require("../../../../../config.json");

    return configs;
  } catch (ex) {
    throw "config.json not found";
  }
};

function submitMSISDN(_x, _x2, _x3, _x4, _x5, _x6) {
  return _submitMSISDN.apply(this, arguments);
}

function _submitMSISDN() {
  _submitMSISDN = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(window, maybeConfig, internationalMSISDN, bupperMSISDN, strategy, extraParams) {
    var config;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            console.table([{
              internationalMSISDN: internationalMSISDN,
              bupperMSISDN: bupperMSISDN
            }]);
            config = strategy ? _objectSpread({
              offer: window.pac_analytics.visitor.offer
            }, strategy.flowConfig) : _objectSpread(_objectSpread({
              offer: window.pac_analytics.visitor.offer
            }, getConfig()), maybeConfig || {});
            return _context.abrupt("return", submitMSISDNWithConfig(window, config, internationalMSISDN, bupperMSISDN, extraParams));

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _submitMSISDN.apply(this, arguments);
}

function submitMSISDNWithConfig(_x7, _x8, _x9, _x10, _x11) {
  return _submitMSISDNWithConfig.apply(this, arguments);
}

function _submitMSISDNWithConfig() {
  _submitMSISDNWithConfig = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(window, config, internationalMSISDN, bupperMSISDN, extraParams) {
    var slug, country, device, offer, host, search, extraParamsQs, msisdn, visitor, rockmanId, ip_range_name, result, type, error;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            slug = config.slug, country = config.country, device = config.device, offer = config.offer, host = config.host;
            search = window.location.search.substr(1) || '';
            extraParamsQs = !extraParams ? '' : '&' + Object.keys(extraParams).map(function (k) {
              return "".concat(k, "=").concat(extraParams[k]);
            }).join('&');
            msisdn = internationalMSISDN.match(/\d+/gi).join('');
            visitor = window.pac_analytics.visitor;
            rockmanId = visitor.rockmanId;

            if (!(country == "ci")) {
              _context2.next = 12;
              break;
            }

            _context2.next = 9;
            return (0, _tryGetIPRangeName.default)(visitor);

          case 9:
            _context2.t0 = _context2.sent;
            _context2.next = 13;
            break;

          case 12:
            _context2.t0 = null;

          case 13:
            ip_range_name = _context2.t0;
            _context2.next = 16;
            return fetch("https://".concat(host, "/tallyman/v1/?action=redirect&slug=").concat(slug, "&country=").concat(country, "&msisdn=").concat(msisdn, "&device=").concat(device, "&offerId=").concat(offer, "&rockman_id=").concat(rockmanId, "&network_type=").concat(!ip_range_name ? "wifi" : "", "&").concat(search).concat(extraParamsQs)).then(function (x) {
              return x.json();
            });

          case 16:
            result = _context2.sent;

            if (!(false === result.success)) {
              _context2.next = 25;
              break;
            }

            type = result.message == 'ALREADY SUBSCRIBED' ? "AlreadySubscribed" : "InvalidMSISDN";
            error = new Error("".concat(type, ":\n").concat(result.message));
            error['type'] = type;
            console.error(error);
            throw error;

          case 25:
            return _context2.abrupt("return", result.redirect_url);

          case 26:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _submitMSISDNWithConfig.apply(this, arguments);
}