import * as React from "react";
import { ITracker } from "../../pacman/record";
import { IFlow } from "../super-strategy/HOC";
import * as RDS from "../../common-types/RemoteDataState";
import { IConfig, ILinkExtraParams } from "./main";
export declare type IdentifyUserErrorTypes = "NotOn3g" | "UnknownError";
export declare type SubscribeUserErrorTypes = "SubscriptionError" | "UnknownError";
export declare type IdentifyFailure = {
    errorType: IdentifyUserErrorTypes;
    error: Error;
};
export declare type IdentifySuccess = {
    redirect_url?: string;
};
export declare type SubscribeSuccess = {
    product_url: string;
};
export declare type SubscribeFailure = {
    errorType: SubscribeUserErrorTypes;
    error: Error;
};
export declare type IState = {
    type: "IDENTIFY";
    result: RDS.RemoteDataState<IdentifyFailure, IdentifySuccess>;
} | {
    type: "SUBSCRIBE";
    result: RDS.RemoteDataState<SubscribeFailure, SubscribeSuccess>;
};
export declare const initialState: IState;
export declare const mockedSubscribeState: IState;
export declare const mockedCompletedState: IState;
declare type IActions = {
    identifyAction: () => any;
    subscribeAction?: () => any;
};
declare type ACompType = React.ComponentType<{
    children: React.ReactNode;
} & React.HTMLAttributes<HTMLAnchorElement>>;
export declare type HOCProps = {
    currentState: IState;
    actions: IActions;
    ProductLink: ACompType;
    RedirectLink: ACompType;
    strategyConfig?: IFlow;
    trackAdvanceInflow?: () => void;
};
export declare function match<R>({ identify, subscribe }: {
    identify: (rds: RDS.RemoteDataState<IdentifyFailure, IdentifySuccess>) => R;
    subscribe: (rds: RDS.RemoteDataState<SubscribeFailure, SubscribeSuccess>) => R;
}): (state: IState) => R;
declare const _default: <P extends HOCProps>(tracker: ITracker, maybeConfig: IConfig, Comp: React.ComponentType<HOCProps>, extraParams?: ILinkExtraParams, strategy?: IFlow) => (initialState: IState, isMocked?: boolean) => {
    new (props: any): {
        state: {
            currentState: IState;
            actions: IActions;
            product_url: string;
            redirect_url: string;
            is_clicked?: boolean;
        };
        UNSAFE_componentWillMount(): Promise<void>;
        componentDidUpdate(): void;
        render(): JSX.Element;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<P>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
        forceUpdate(callback?: () => void): void;
        readonly props: Readonly<P> & Readonly<{
            children?: React.ReactNode;
        }>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<P>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<P>, prevState: Readonly<{}>): any;
        componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<P>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<P>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<P>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<P>, nextState: Readonly<{}>, nextContext: any): void;
    };
    contextType?: React.Context<any>;
};
export default _default;
