import { IFlow } from "../super-strategy/HOC";
export declare type IClickActionTypes = "he" | "redirect" | "identify-user";
export declare type IConfig = {
    host?: string;
    country?: string;
    slug?: string;
    queryString?: Array<[string, string]>;
    device?: string;
    apiAction?: IClickActionTypes;
};
export interface ILinkExtraParams {
    [key: string]: string;
}
export declare type IIDentifyUserResult = {
    success: true;
    rockman_id: string;
    subscription_url?: string;
    redirect_url?: string;
} | {
    success: false;
    rockman_id: string;
    message: string;
};
export declare type IHEResult = {
    success: true;
    rockman_id: string;
    redirectUrlWithReplacedUniqid?: string;
    source: string;
    oldUniqid: string;
    newUniqid: string;
} | {
    success: false;
    rockman_id: string;
    message: string;
};
export declare type ISubscribeResult = {
    success: true;
    rockman_id: string;
    product_url: string;
} | {
    success: false;
    rockman_id: string;
    message: string;
};
declare const getRedirectUrl: (maybeConfig: IConfig, extraParams?: ILinkExtraParams, strategy?: IFlow) => Promise<{
    subscription_url?: string;
    redirect_url?: string;
    action?: () => Promise<string>;
}>;
export default getRedirectUrl;
