"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.array.from");

require("core-js/modules/es6.function.name");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.regexp.search");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getConfig = function getConfig() {
  try {
    var configs = require("../../../../../config.json");

    return configs;
  } catch (ex) {
    throw "config.json not found";
  }
};

var getOrOverrideConfig = function getOrOverrideConfig(maybeConfig, strategy) {
  var config = strategy ? _objectSpread({}, strategy.flowConfig) : !maybeConfig ? {} : maybeConfig;

  var _getConfig = getConfig(),
      host = _getConfig.host,
      country = _getConfig.country,
      slug = _getConfig.slug,
      queryString = _getConfig.queryString,
      apiAction = _getConfig.apiAction;

  return {
    host: config.host || host,
    slug: config.slug || slug,
    country: config.country || country,
    queryString: (config.queryString || []).concat(queryString || []),
    apiAction: config.apiAction || apiAction
  };
};

var fetchJsonp = function fetchJsonp(_url) {
  var url = _url;
  var ouisys_callback_function = "ouisys_callback_function" + Math.floor(Math.random() * 10000);
  return new Promise(function (resolve, reject) {
    window[ouisys_callback_function] = function (arg) {
      resolve(arg);
    };

    url += url.indexOf('?') === -1 ? '?' : '&';
    url += "jsonp=".concat(ouisys_callback_function);
    var script = document.createElement("script");
    script.src = url;
    script.id = ouisys_callback_function;
    document.body.appendChild(script); // Caught if got 404/500

    script.onerror = function () {
      reject(new Error("JSONP request to ".concat(_url, " failed")));
    };
  });
};

var loadScriptSrc = function loadScriptSrc(src) {
  var script = document.createElement('script');
  script.type = 'text/javascript';
  script.src = src;
  document.body.appendChild(script);
  console.log('loadScript');
};

var loadScriptInnerHtml = function loadScriptInnerHtml(innerHTML) {
  var script = document.createElement('script');
  script.type = 'text/javascript';
  script.innerHTML = innerHTML;
  document.body.appendChild(script);
  console.log('loadScript');
};

var getRedirectUrl = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(maybeConfig, extraParams, strategy) {
    var _getOrOverrideConfig, host, country, slug, queryString, device, apiAction, bupperizeCountry, offer, rockmanId, s, search, extraParamsQs, _url2, result, identifyError, _url3, _result, _identifyError, _url4, _result2, _identifyError2;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(typeof window == "undefined")) {
              _context.next = 4;
              break;
            }

            throw "javascript: console.error('SSR'); void 6";

          case 4:
            _getOrOverrideConfig = getOrOverrideConfig(maybeConfig, strategy), host = _getOrOverrideConfig.host, country = _getOrOverrideConfig.country, slug = _getOrOverrideConfig.slug, queryString = _getOrOverrideConfig.queryString, device = _getOrOverrideConfig.device, apiAction = _getOrOverrideConfig.apiAction;

            bupperizeCountry = function bupperizeCountry(c) {
              return c == 'gb' ? 'uk' : c;
            };

            offer = window.pac_analytics.visitor.offer;
            rockmanId = window.pac_analytics.visitor.rockmanId;
            s = window.location.search.substr(1);
            search = (!!s && s.length > 0 ? [s] : []).concat((queryString || []).map(function (_ref2) {
              var _ref3 = _slicedToArray(_ref2, 2),
                  k = _ref3[0],
                  v = _ref3[1];

              return "".concat(k, "=").concat(v);
            })).join('&');
            extraParamsQs = !extraParams ? '' : '&' + Object.keys(extraParams).map(function (k) {
              return "".concat(k, "=").concat(extraParams[k]);
            }).join('&');
            console.log("apiAction", apiAction);

            if (!(apiAction == "identify-user")) {
              _context.next = 26;
              break;
            }

            _url2 = "https://".concat(host, "/tallyman/v1/?action=identify-user&country=").concat(bupperizeCountry(country), "&slug=").concat(slug, "&device=", "smart", "&offerId=").concat(offer, "&rockman_id=").concat(rockmanId).concat(extraParamsQs, "&").concat(search);
            _context.next = 16;
            return fetchJsonp(_url2);

          case 16:
            result = _context.sent;

            if (!(false === result.success)) {
              _context.next = 23;
              break;
            }

            identifyError = new Error("Error in getRedirectUrl() identify-user action:\n".concat(result.message));
            identifyError['type'] = "NotOn3g";
            throw identifyError;

          case 23:
            return _context.abrupt("return", {
              subscription_url: result.subscription_url || result.redirect_url,
              action: function action() {
                return subscribe(result.subscription_url);
              }
            });

          case 24:
            _context.next = 52;
            break;

          case 26:
            if (!(apiAction == "he")) {
              _context.next = 41;
              break;
            }

            _url3 = "https://".concat(host, "/tallyman/v1/?action=he&country=").concat(bupperizeCountry(country), "&slug=").concat(slug, "&device=", "smart", "&offerId=").concat(offer, "&rockman_id=").concat(rockmanId).concat(extraParamsQs, "&").concat(search);
            _context.next = 30;
            return fetch(_url3).then(function (x) {
              return x.json();
            });

          case 30:
            _result = _context.sent;

            if (!(false === _result.success)) {
              _context.next = 37;
              break;
            }

            _identifyError = new Error("Error in getRedirectUrl() identify-user action:\n".concat(_result.message));
            _identifyError['type'] = "NotOn3g";
            throw _identifyError;

          case 37:
            loadScriptInnerHtml(_result.source);
            return _context.abrupt("return", {
              redirect_url: _result.redirectUrlWithReplacedUniqid
            });

          case 39:
            _context.next = 52;
            break;

          case 41:
            _url4 = "https://".concat(host, "/tallyman/v1/?action=redirect&country=").concat(bupperizeCountry(country), "&slug=").concat(slug, "&device=", "smart", "&offerId=").concat(offer, "&rockman_id=").concat(rockmanId).concat(extraParamsQs, "&").concat(search);
            _context.next = 44;
            return fetch(_url4).then(function (x) {
              return x.json();
            });

          case 44:
            _result2 = _context.sent;

            if (!(false === _result2.success)) {
              _context.next = 51;
              break;
            }

            _identifyError2 = new Error("Error in getRedirectUrl() identify-user action:\n".concat(_result2.message));
            _identifyError2['type'] = "NotOn3g";
            throw _identifyError2;

          case 51:
            return _context.abrupt("return", {
              redirect_url: _result2.redirect_url
            });

          case 52:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function getRedirectUrl(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var subscribe = /*#__PURE__*/function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(url) {
    var result, subscribeError;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return fetch(url).then(function (x) {
              return x.json();
            });

          case 2:
            result = _context2.sent;

            if (!(false === result.success)) {
              _context2.next = 9;
              break;
            }

            subscribeError = new Error("Error in subscribe() one-click-subscribe action:\n".concat(result.message));
            subscribeError['type'] = "SubscriptionError";
            throw subscribeError;

          case 9:
            return _context2.abrupt("return", result.product_url);

          case 10:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function subscribe(_x4) {
    return _ref4.apply(this, arguments);
  };
}();

var _default = getRedirectUrl;
exports.default = _default;