import { IFlow } from "../super-strategy/HOC";
export declare type IConfig = {
    offer: number;
    slug?: string;
    country?: string;
    host?: string;
    device?: "smart" | "feature";
    automaticallySubmitAllOperators?: boolean;
    operators?: string[];
};
export declare type IMSISDNSubmissionResult = {
    success: true;
    rockman_id: string;
    pin: string;
    product_url?: string;
} | {
    success: false;
    rockman_id: string;
    message: string;
    product_url?: string;
};
export declare type IPINSubmissionResult = {
    success: true;
    rockman_id: string;
    product_url?: string;
    async?: boolean;
} | {
    success: false;
    rockman_id: string;
    message: string;
};
export declare type ICheckSubscriptionResult = {
    success: false;
    rockman_id: string;
    message: string;
} | {
    success: true;
    msisdn: string;
    product_url?: string;
    rockman_id: string;
};
export interface IHash {
    [key: string]: string;
}
export declare type SingleMSISDNSubmissionResult = {
    type: "SingleMSISDNSubmissionResult";
    pin?: string;
    submitPIN: (pin: string) => Promise<string>;
};
export declare type MultiOperatorMSISDNSubmissionResult = {
    type: "MultiOperatorMSISDNSubmissionResult";
    submitPIN: (pin: string) => Promise<string>;
};
export default function submitMSISDN(window: Window, maybeConfig: IConfig, internationalMSISDN: string, strategy?: IFlow, extraParams?: IHash): Promise<SingleMSISDNSubmissionResult | MultiOperatorMSISDNSubmissionResult>;
