"use strict";

require("core-js/modules/es6.regexp.match");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.weak-map");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.match = match;
exports.MatchSuccess = MatchSuccess;
exports.initialState = exports.mockFailureState = exports.mockSuccessState = exports.mockLoadingState = exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.assign");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.reflect.construct");

require("core-js/modules/es6.object.set-prototype-of");

var React = _interopRequireWildcard(require("react"));

var TAPI = _interopRequireWildcard(require("./TolaAPI"));

var RDS = _interopRequireWildcard(require("../../common-types/RemoteDataState"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function match(matcher) {
  return function (rds) {
    return RDS.match(matcher)(rds);
  };
}

function MatchSuccess(matcher) {
  return function (rds) {
    return RDS.MatchSuccess(matcher)(rds);
  };
}

var _default = function _default(tracker, visitor) {
  return function (Comp) {
    return function (initState) {
      var _temp;

      return _temp = /*#__PURE__*/function (_React$Component) {
        _inherits(HOC, _React$Component);

        var _super = _createSuper(HOC);

        function HOC(props) {
          var _this;

          _classCallCheck(this, HOC);

          _this = _super.call(this, props);

          _defineProperty(_assertThisInitialized(_this), "state", void 0);

          _defineProperty(_assertThisInitialized(_this), "actions", void 0);

          _this.state = {
            current: initState
          };

          var self = _assertThisInitialized(_this);

          _this.actions = {
            chargeAndWait: function chargeAndWait(msisdn, message, price) {
              if (!msisdn || msisdn.length == 0) {
                self.setState({
                  current: RDS.Failure({
                    type: "InvalidMSISDN"
                  })
                });
                return;
              }

              return TAPI.chargeAndWait(visitor, msisdn, message, price, function (st) {
                self.setState({
                  current: st
                });
                RDS.match({
                  loading: function loading() {
                    return tracker.advancedInFlow('tola', 'chargeAndWait', {
                      msisdn: msisdn,
                      message: message,
                      price: price
                    });
                  },
                  success: function success() {
                    return tracker.advancedInFlow('tola', 'success', {
                      msisdn: msisdn,
                      message: message,
                      price: price
                    });
                  },
                  failure: function failure(error) {
                    return tracker.recedeInFlow('tola', 'failure', {
                      error: error.type
                    });
                  },
                  nothingYet: function nothingYet() {
                    return void 8;
                  }
                })(st);
              });
            },
            backToNothingYet: function backToNothingYet() {
              return self.setState({
                current: RDS.NothingYet()
              });
            }
          };
          return _this;
        }

        _createClass(HOC, [{
          key: "render",
          value: function render() {
            var self = this;
            return /*#__PURE__*/React.createElement(Comp, _extends({
              actions: self.actions,
              currentState: self.state.current
            }, this.props));
          }
        }]);

        return HOC;
      }(React.Component), _temp;
    };
  };
};

exports.default = _default;
var mockLoadingState = RDS.Loading();
exports.mockLoadingState = mockLoadingState;
var mockSuccessState = RDS.Success({});
exports.mockSuccessState = mockSuccessState;

var mockFailureState = function mockFailureState(err) {
  return RDS.Failure(err);
};

exports.mockFailureState = mockFailureState;
var initialState = RDS.NothingYet();
exports.initialState = initialState;