"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.weak-map");

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

require("regenerator-runtime/runtime");

var _inquirer = _interopRequireDefault(require("inquirer"));

var fs = _interopRequireWildcard(require("fs"));

var _path = _interopRequireDefault(require("path"));

var envfile = _interopRequireWildcard(require("envfile"));

var _child_process = require("child_process");

var util = _interopRequireWildcard(require("util"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var env = envfile.parseFileSync(_path.default.resolve("", ".env"));

var execute = function execute(command, callback) {
  (0, _child_process.exec)(command, function (error, stdout, stderr) {
    return callback(stdout);
  });
};

var execPromise = util.promisify(require('child_process').exec);

var createAbTest = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var _yield$inquirer$promp, page_name, updatedEnvContent, _yield$execPromise, stdout, stderr;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            console.log("⚠️ IMPORTANT: Please confirm or change the following before building your project!");
            console.log("Press <enter> to accept default or type in a new value and press <enter>");
            _context.next = 4;
            return _inquirer.default.prompt([{
              type: "input",
              name: "page_name",
              message: "A/B Test Page Name:"
            }]);

          case 4:
            _yield$inquirer$promp = _context.sent;
            page_name = _yield$inquirer$promp.page_name;
            updatedEnvContent = envfile.stringifySync(_objectSpread(_objectSpread({}, env), {}, {
              page: page_name || env.page
            }));
            _context.next = 9;
            return execPromise("git branch abtest/".concat(page_name));

          case 9:
            _yield$execPromise = _context.sent;
            stdout = _yield$execPromise.stdout;
            stderr = _yield$execPromise.stderr;

            if (!(stderr !== "")) {
              _context.next = 18;
              break;
            }

            console.log("\uD83D\uDED1 ERROR: Creating A/B Test Branch: ".concat(JSON.stringify(stderr)));
            process.exit(-1);
            return _context.abrupt("return");

          case 18:
            _context.next = 20;
            return execPromise("git checkout abtest/".concat(page_name));

          case 20:
            fs.writeFileSync(_path.default.resolve("", ".env"), updatedEnvContent, "utf8");
            console.log("A/B Test Branch Created! 😊");

          case 22:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function createAbTest() {
    return _ref.apply(this, arguments);
  };
}();

createAbTest();