"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.weak-map");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(require("path"));

var _fs = require("fs");

var _axios = _interopRequireDefault(require("axios"));

var envfile = _interopRequireWildcard(require("envfile"));

var _child_process = require("child_process");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var execute = function execute(command, callback) {
  (0, _child_process.exec)(command, function (error, stdout, stderr) {
    return callback(stdout);
  });
};

var disclaimerPath = "./src/localization/translations/legals.json";
var env = envfile.parseFileSync(_path.default.resolve("", ".env"));
var country = env.country,
    service = env.service,
    scenario = env.scenario;

var writeDisclaimers = function writeDisclaimers(data, isSuccess) {
  (0, _fs.writeFileSync)(disclaimerPath, JSON.stringify(data, null, 2), "utf8");

  if (isSuccess) {
    console.log("\uD83D\uDE07 Disclaimers generated here ".concat(_path.default.resolve("", "src/localization/translations/legals.json")));
  }
};

var getLegals = function getLegals() {
  return (0, _axios.default)({
    url: 'https://c1.ouisys.com/api/v1/get-page-legals',
    //url:'http://localhost:3030/api/v1/get-page-legals',
    method: 'get',
    params: {
      country: country,
      service: service,
      scenario: scenario
    }
  }).then(function (response) {
    if (response.data.length > 0) {
      writeDisclaimers(response.data, true);
    } else {
      writeDisclaimers([], false);
      console.log(" \uD83D\uDE14 ERROR: Could not get any disclaimers for the given data. Please check your .env file");
      console.table([{
        country: country,
        scenario: scenario,
        service: service
      }]);
    }

    return response.data;
  }).catch(function (err) {
    console.error(err);
  });
};

var _default = getLegals;
exports.default = _default;