"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.weak-map");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es7.array.includes");

require("core-js/modules/es6.string.includes");

require("regenerator-runtime/runtime");

var _path = _interopRequireDefault(require("path"));

var _fs = require("fs");

var _axios = _interopRequireDefault(require("axios"));

var envfile = _interopRequireWildcard(require("envfile"));

var _child_process = require("child_process");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var execute = function execute(command, callback) {
  (0, _child_process.exec)(command, function (error, stdout, stderr) {
    return callback(stdout);
  });
};

var disclaimerPath = "./src/localization/translations/legals.json";
var env = envfile.parseFileSync(_path.default.resolve("", ".env"));
var extraConfigInfo = {
  pinScenario: null,
  moScenario: null,
  oneClickScenario: null,
  pinService: null,
  moService: null,
  oneClickService: null
};
var country = env.country,
    pinScenario = env.pinScenario,
    moScenario = env.moScenario,
    oneClickScenario = env.oneClickScenario,
    pinService = env.pinService,
    moService = env.moService,
    oneClickService = env.oneClickService,
    click2smsScenario = env.click2smsScenario,
    click2smsService = env.click2smsService;
var serviceScenarios = [{
  scenario: pinScenario,
  service: pinService,
  key: "pin"
}, {
  scenario: moScenario,
  service: moService,
  key: "mo"
}, {
  scenario: oneClickScenario,
  service: oneClickService,
  key: "oneClick"
}, {
  scenario: click2smsScenario,
  service: click2smsService,
  key: "click2sms"
}];

var getLegals = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(scenario, service) {
    var response;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return (0, _axios.default)({
              url: 'https://c1.ouisys.com/api/v1/get-page-legals',
              //url:'http://localhost:3030/api/v1/get-page-legals',
              method: 'get',
              params: {
                country: country,
                service: service,
                scenario: scenario
              }
            });

          case 3:
            response = _context.sent;
            return _context.abrupt("return", response.data);

          case 7:
            _context.prev = 7;
            _context.t0 = _context["catch"](0);
            throw _context.t0;

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 7]]);
  }));

  return function getLegals(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var arrToSubmit = serviceScenarios.filter(function (obj) {
  return obj.scenario !== undefined && obj.service;
});

function getAllLegals() {
  return _getAllLegals.apply(this, arguments);
}

function _getAllLegals() {
  _getAllLegals = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
    var response;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return Promise.all(arrToSubmit.map( /*#__PURE__*/function () {
              var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(obj) {
                var legals;
                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        if (!(obj.scenario !== "undefined" && obj.service !== "undefined")) {
                          _context3.next = 16;
                          break;
                        }

                        _context3.prev = 1;
                        _context3.next = 4;
                        return getLegals(obj.scenario, obj.service);

                      case 4:
                        legals = _context3.sent;

                        if (!(legals.length > 0)) {
                          _context3.next = 9;
                          break;
                        }

                        //append flow to each object
                        legals.map(function (l) {
                          l.flow = obj.key;
                        });
                        _context3.next = 10;
                        break;

                      case 9:
                        throw "Can't get legals Scenario: ".concat(obj.scenario, " and Service:").concat(obj.service);

                      case 10:
                        return _context3.abrupt("return", legals);

                      case 13:
                        _context3.prev = 13;
                        _context3.t0 = _context3["catch"](1);
                        throw _context3.t0;

                      case 16:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3, null, [[1, 13]]);
              }));

              return function (_x3) {
                return _ref3.apply(this, arguments);
              };
            }()));

          case 2:
            response = _context4.sent;
            return _context4.abrupt("return", Array.prototype.concat.apply([], response));

          case 4:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _getAllLegals.apply(this, arguments);
}

;

var writeDisclaimers = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var data;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            _context2.next = 3;
            return getAllLegals();

          case 3:
            data = _context2.sent;

            if (!(data.length > 0 && !data.includes(null))) {
              _context2.next = 10;
              break;
            }

            (0, _fs.writeFileSync)(disclaimerPath, JSON.stringify(data, null, 2), "utf8");
            console.log("\uD83D\uDE07 Disclaimers generated here ".concat(_path.default.resolve("", "src/localization/translations/legals.json")));
            return _context2.abrupt("return");

          case 10:
            (0, _fs.writeFileSync)(disclaimerPath, JSON.stringify([], null, 2), "utf8");
            console.log(" \uD83D\uDE14 ERROR: Could not get any disclaimers for the given data. Please check your .env file");
            return _context2.abrupt("return");

          case 13:
            _context2.next = 18;
            break;

          case 15:
            _context2.prev = 15;
            _context2.t0 = _context2["catch"](0);
            throw _context2.t0;

          case 18:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[0, 15]]);
  }));

  return function writeDisclaimers() {
    return _ref2.apply(this, arguments);
  };
}();

var _default = writeDisclaimers;
exports.default = _default;