"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.translate = translate;
exports.translateHash = translateHash;

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.array.from");

require("core-js/modules/es6.function.name");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

var _tinyAsyncPool = _interopRequireDefault(require("tiny-async-pool"));

var _nodeFetch = _interopRequireDefault(require("node-fetch"));

var _ramda = _interopRequireDefault(require("ramda"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function translate(_x, _x2, _x3) {
  return _translate.apply(this, arguments);
}

function _translate() {
  _translate = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(from, to, texts) {
    var osui_yandex_key, translateOneBatch, batches, results;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            osui_yandex_key = process.env.osui_yandex_key;

            if (osui_yandex_key) {
              _context2.next = 3;
              break;
            }

            throw "osui_yandex_key environment variable is missing. This is necessary for Yandex translation.";

          case 3:
            translateOneBatch = /*#__PURE__*/function () {
              var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(ts) {
                var qs, res;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        qs = ts.map(function (t) {
                          return "text=".concat(encodeURIComponent(t));
                        }).join("&");
                        _context.next = 3;
                        return (0, _nodeFetch.default)("https://translate.yandex.net/api/v1.5/tr.json/translate?key=".concat(osui_yandex_key, "&").concat(qs, "&lang=").concat(from, "-").concat(to)).then(function (x) {
                          return x.json();
                        }).then(function (x) {
                          return x.text;
                        });

                      case 3:
                        res = _context.sent;
                        return _context.abrupt("return", res);

                      case 5:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function translateOneBatch(_x7) {
                return _ref.apply(this, arguments);
              };
            }(); // Yandex supports multiple text parameters in the query string, so we can translate our array in batches.


            batches = _ramda.default.splitEvery(9, texts);
            _context2.next = 7;
            return (0, _tinyAsyncPool.default)(2, batches, translateOneBatch);

          case 7:
            results = _context2.sent;
            return _context2.abrupt("return", _ramda.default.chain(function (x) {
              return x;
            }, results));

          case 9:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _translate.apply(this, arguments);
}

function translateHash(_x4, _x5, _x6) {
  return _translateHash.apply(this, arguments);
}

function _translateHash() {
  _translateHash = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(from, to, hash) {
    var pairs, values, zipped;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            pairs = _ramda.default.toPairs(hash);
            _context3.next = 3;
            return translate(from, to, pairs.map(function (p) {
              return p[1];
            }));

          case 3:
            values = _context3.sent;
            zipped = _ramda.default.zip(pairs, values).map(function (_ref2) {
              var _ref3 = _slicedToArray(_ref2, 2),
                  _ref3$ = _slicedToArray(_ref3[0], 2),
                  k = _ref3$[0],
                  _ = _ref3$[1],
                  v = _ref3[1];

              return [k, v];
            });
            return _context3.abrupt("return", _ramda.default.fromPairs(zipped));

          case 6:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _translateHash.apply(this, arguments);
}