"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.weak-map");

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.regexp.split");

require("core-js/modules/es7.array.includes");

require("core-js/modules/es6.string.includes");

require("regenerator-runtime/runtime");

var _inquirer = _interopRequireDefault(require("inquirer"));

var fs = _interopRequireWildcard(require("fs"));

var _path = _interopRequireDefault(require("path"));

var envfile = _interopRequireWildcard(require("envfile"));

var _child_process = require("child_process");

var util = _interopRequireWildcard(require("util"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var env = envfile.parseFileSync(_path.default.resolve("", ".env"));

var execute = function execute(command, callback) {
  (0, _child_process.exec)(command, function (error, stdout, stderr) {
    return callback(stdout);
  });
};

var execPromise = util.promisify(require('child_process').exec);

var preBuild = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
    var updateConfig, _yield$inquirer$promp, client, _yield$inquirer$promp2, title, _yield$inquirer$promp3, country, _yield$inquirer$promp4, page, _yield$inquirer$promp5, scenario, _yield$inquirer$promp6, service, _yield$inquirer$promp7, strategy, _yield$inquirer$promp8, scenariosConfig;

    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            console.log("⚠️ IMPORTANT: Please confirm or change the following before building your project!");
            console.log("Press <enter> to accept default or type in a new value and press <enter>");

            updateConfig = function updateConfig(extraItems) {
              var updatedEnvContent = envfile.stringifySync(_objectSpread(_objectSpread({}, env), {}, {
                client: client || env.client,
                title: title || env.title,
                country: country || env.country,
                page: page || env.page
              }, extraItems));
              execute("basename -s .git `git config --get remote.origin.url`", /*#__PURE__*/function () {
                var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(repo_name) {
                  var repoName, myPage, _yield$execPromise, stdout, stderr, branch;

                  return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          repoName = repo_name.trim();
                          myPage = page ? page : env.page;
                          _context.next = 4;
                          return execPromise("git rev-parse --abbrev-ref HEAD");

                        case 4:
                          _yield$execPromise = _context.sent;
                          stdout = _yield$execPromise.stdout;
                          stderr = _yield$execPromise.stderr;
                          branch = stdout.trim();
                          console.log("BRANCH NAME", branch);
                          console.log("repoName", repoName);
                          console.log("PAGE", myPage);

                          if (!(branch.includes("abtest/") && branch.split("/")[1] !== myPage)) {
                            _context.next = 17;
                            break;
                          }

                          console.log("\uD83D\uDED1 ERROR: Page name: ".concat(myPage, " must match git branch basename: ").concat(branch.split("/")[1]));
                          process.exit(-1);
                          return _context.abrupt("return");

                        case 17:
                          if (!(!branch.includes("abtest/") && myPage !== repoName && process.env.SKIPCHECKS != "true")) {
                            _context.next = 23;
                            break;
                          }

                          console.log("\uD83D\uDED1 ERROR: Page name: ".concat(myPage, " must match git repo name: ").concat(repoName));
                          process.exit(-1);
                          return _context.abrupt("return");

                        case 23:
                          fs.writeFileSync(_path.default.resolve("", ".env"), updatedEnvContent, "utf8");
                          console.log(".env updated! 😊");
                          console.table([_objectSpread({
                            client: client || env.client,
                            title: title || env.title,
                            country: country || env.country,
                            page: page || env.page
                          }, extraItems)]);
                          console.log("Building project please wait...");

                        case 27:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                return function (_x) {
                  return _ref2.apply(this, arguments);
                };
              }());
            };

            _context3.next = 5;
            return _inquirer.default.prompt([{
              type: "input",
              name: "client",
              message: "Client:  ".concat(env.client ? "(".concat(env.client, ")") : "")
            }]);

          case 5:
            _yield$inquirer$promp = _context3.sent;
            client = _yield$inquirer$promp.client;
            _context3.next = 9;
            return _inquirer.default.prompt([{
              type: "input",
              name: "title",
              message: "Title:  ".concat(env.title ? "(".concat(env.title, ")") : "")
            }]);

          case 9:
            _yield$inquirer$promp2 = _context3.sent;
            title = _yield$inquirer$promp2.title;
            _context3.next = 13;
            return _inquirer.default.prompt([{
              type: "input",
              name: "country",
              message: "Country:  ".concat(env.country ? "(".concat(env.country, ")") : "")
            }]);

          case 13:
            _yield$inquirer$promp3 = _context3.sent;
            country = _yield$inquirer$promp3.country;
            _context3.next = 17;
            return _inquirer.default.prompt([{
              type: "input",
              name: "page",
              message: "Page:  ".concat(env.page ? "(".concat(env.page, ")") : "")
            }]);

          case 17:
            _yield$inquirer$promp4 = _context3.sent;
            page = _yield$inquirer$promp4.page;

            if (env.strategy) {
              _context3.next = 31;
              break;
            }

            _context3.next = 22;
            return _inquirer.default.prompt([{
              type: "input",
              name: "scenario",
              message: "Scenario:  ".concat(env.scenario ? "(".concat(env.scenario, ")") : "")
            }]);

          case 22:
            _yield$inquirer$promp5 = _context3.sent;
            scenario = _yield$inquirer$promp5.scenario;
            _context3.next = 26;
            return _inquirer.default.prompt([{
              type: "input",
              name: "service",
              message: "Service:  ".concat(env.service ? "(".concat(env.service, ")") : "")
            }]);

          case 26:
            _yield$inquirer$promp6 = _context3.sent;
            service = _yield$inquirer$promp6.service;
            updateConfig({
              scenario: scenario || env.scenario,
              service: service || env.service
            });
            _context3.next = 40;
            break;

          case 31:
            _context3.next = 33;
            return _inquirer.default.prompt([{
              type: "input",
              name: "strategy",
              message: "Strategy:  ".concat(env.strategy ? "(".concat(env.strategy, ")") : "")
            }]);

          case 33:
            _yield$inquirer$promp7 = _context3.sent;
            strategy = _yield$inquirer$promp7.strategy;
            _context3.next = 37;
            return _inquirer.default.prompt([{
              type: "input",
              name: "scenariosConfig",
              message: "ScenariosConfig:  ".concat(env.scenariosConfig ? "(".concat(env.scenariosConfig, ")") : "")
            }]);

          case 37:
            _yield$inquirer$promp8 = _context3.sent;
            scenariosConfig = _yield$inquirer$promp8.scenariosConfig;
            updateConfig({
              strategy: strategy || env.strategy,
              scenariosConfig: scenariosConfig || env.scenariosConfig
            });

          case 40:
            execute("basename `yarn generate:legals`", /*#__PURE__*/function () {
              var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(legals) {
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        console.log("GENERATING LEGALS");

                      case 1:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              return function (_x2) {
                return _ref3.apply(this, arguments);
              };
            }());

          case 41:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function preBuild() {
    return _ref.apply(this, arguments);
  };
}();

preBuild();