"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.weak-map");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.object.to-string");

var _path = _interopRequireDefault(require("path"));

var _axios = _interopRequireDefault(require("axios"));

var _s = _interopRequireDefault(require("aws-sdk/clients/s3"));

var _slugify = _interopRequireDefault(require("slugify"));

var envfile = _interopRequireWildcard(require("envfile"));

var _moment = _interopRequireDefault(require("moment"));

var _child_process = require("child_process");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var execute = function execute(command, callback) {
  (0, _child_process.exec)(command, function (error, stdout, stderr) {
    return callback(stdout);
  });
};

var env = envfile.parseFileSync(_path.default.resolve("", ".env"));
var BUCKET_NAME = "mobirun";
var client = new _s.default({
  accessKeyId: process.env.osui_aws_access_key_id,
  secretAccessKey: process.env.osui_secret_access_key
});

function publishPage(s3UploadDir, s3StageFile, s3ProdFile) {
  var s3FullPathStage = s3UploadDir + s3StageFile;
  var s3FullPathProd = s3UploadDir + s3ProdFile;
  console.log("Publishing ".concat(s3StageFile, " -> ").concat(s3ProdFile));
  console.log("".concat(BUCKET_NAME, "/").concat(s3FullPathStage));
  client.copyObject({
    Bucket: BUCKET_NAME,
    CopySource: "".concat(BUCKET_NAME, "/").concat(s3FullPathStage),
    Key: s3FullPathProd,
    ACL: 'public-read'
  }).promise().then(function (res) {
    console.log(res);
  }).catch(function (err) {
    console.error(err);
  });
}

function cacheAndPublishPage(s3UploadDir, s3StageFile, s3ProdFile) {
  var now = (0, _moment.default)().format("YYYYMMDDHHMMSS").toString();
  var cachePageName = "".concat(s3ProdFile, ".").concat(now);
  var s3FullPathProd = s3UploadDir + s3ProdFile;
  console.log("Caching current ".concat(s3ProdFile, " -> ").concat(cachePageName));
  client.copyObject({
    Bucket: BUCKET_NAME,
    CopySource: "".concat(BUCKET_NAME, "/").concat(s3FullPathProd),
    Key: s3UploadDir + cachePageName,
    ACL: 'public-read'
  }).promise().then(function () {
    return client.deleteObject({
      Bucket: BUCKET_NAME,
      Key: s3FullPathProd
    }).promise().then(function () {
      return publishPage(s3UploadDir, s3StageFile, s3ProdFile);
    });
  }).catch(function (err) {
    console.error(err);
  });
}

function main() {
  return _main.apply(this, arguments);
}

function _main() {
  _main = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var page, country, scenario, strategy, scenariosConfig, slugifiedString, s3UploadDir, s3ProdFile, s3StageFile, params;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            page = env.page, country = env.country, scenario = env.scenario, strategy = env.strategy, scenariosConfig = env.scenariosConfig;
            slugifiedString = scenario ? (0, _slugify.default)(scenario, {
              lower: true
            }) : (0, _slugify.default)("".concat(strategy, "_").concat(scenariosConfig), {
              lower: true
            });
            s3UploadDir = "os-ui/static/".concat(page, "/html/");
            s3ProdFile = "".concat(country, "-").concat(slugifiedString, "-production.html");
            s3StageFile = "".concat(country, "-").concat(slugifiedString, "-staging.html");
            params = {
              Bucket: BUCKET_NAME,
              Key: s3UploadDir + s3ProdFile
            }; // Check whether file exist or not
            // and perform appropriate action

            client.headObject(params, function (err, data) {
              if (err && err.statusCode === 404) {
                publishPage(s3UploadDir, s3StageFile, s3ProdFile);
              } else {
                cacheAndPublishPage(s3UploadDir, s3StageFile, s3ProdFile);
              }
            });

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _main.apply(this, arguments);
}

var apiUrl = "http://127.0.0.1:3030"; //const apiUrl = "https://c1.ouisys.com";

main().then(function () {
  //save the page upload to the database
  var country = env.country,
      page = env.page,
      scenario = env.scenario,
      strategy = env.strategy,
      scenariosConfig = env.scenariosConfig;
  var slugifiedString = scenario ? (0, _slugify.default)(scenario, {
    lower: true
  }) : (0, _slugify.default)("".concat(strategy, "_").concat(scenariosConfig), {
    lower: true
  });
  var s3UploadDir = "os-ui/static/".concat(page, "/html/");
  var s3ProdFile = "".concat(country, "-").concat(slugifiedString, "-production.html");
  var s3Page = "https://".concat(s3UploadDir).concat(s3ProdFile);

  var releasePage = function releasePage(data) {
    (0, _axios.default)({
      url: "".concat(apiUrl, "/api/v1/release-page"),
      method: 'post',
      data: {
        html_url: s3Page,
        page_upload_id: data.id,
        username: data.git_username
      }
    }).then(function (response) {
      console.log("release page response", response);
      console.log("Page released", "http://c1.ouisys.com/preview/?country=".concat(country, "&page=").concat(page, "&scenario=").concat(slugifiedString));
      return response.data;
    }).catch(function (err) {
      console.error(err);
    });
  };

  (0, _axios.default)({
    url: "".concat(apiUrl, "/api/v1/get-page"),
    method: 'get',
    params: {
      page: page,
      country: country,
      scenario: slugifiedString,
      strategy: strategy,
      scenarios_config: scenariosConfig
    }
  }).then(function (response) {
    return response.data;
  }).then(function (data) {
    releasePage(data);
  }).catch(function (err) {
    console.error(err);
  });
}).catch(console.error);