"use strict";

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.array.from");

require("core-js/modules/es6.function.name");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.regexp.split");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

var _fs = _interopRequireDefault(require("fs"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _path = _interopRequireDefault(require("path"));

var _slugify = _interopRequireDefault(require("slugify"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var envfile = require("envfile");

var env = envfile.parseFileSync(_path.default.resolve("", ".env"));

var _require = require("react-dom/server"),
    renderToString = _require.renderToString;

var React = require("react");

require("dotenv").config();

var country = env.country,
    page = env.page,
    scenario = env.scenario,
    strategy = env.strategy,
    scenariosConfig = env.scenariosConfig;
var NOREACT = "true" == process.env.noReact || "true" == process.env.NOREACT;
var slugifiedString = scenario ? (0, _slugify.default)(scenario, {
  lower: true
}) : (0, _slugify.default)("".concat(strategy, "_").concat(scenariosConfig), {
  lower: true
});
var stageIndexFileName = "".concat(country, "-").concat(slugifiedString, "-staging.html");
var entryHtmlFile = stageIndexFileName;

var inputFileName = _path.default.join(_path.default.resolve("", "./dist/static/".concat(page, "/html"), "index.html"));

var outputFileName = _path.default.join(_path.default.resolve("", "./dist/static/".concat(page, "/html"), stageIndexFileName));

console.log(stageIndexFileName);
console.log(outputFileName);

function copyAssets() {
  return _copyAssets.apply(this, arguments);
}

function _copyAssets() {
  _copyAssets = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _fsExtra.default.existsSync(_path.default.resolve("", "./assets"));

          case 2:
            if (!_context.sent) {
              _context.next = 6;
              break;
            }

            _fsExtra.default.copy(_path.default.resolve("", "./assets"), _path.default.resolve("", "./dist/static/".concat(page, "/")));

            _context.next = 7;
            break;

          case 6:
            Promise.resolve();

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _copyAssets.apply(this, arguments);
}

function mainWithoutReact() {
  return _mainWithoutReact.apply(this, arguments);
}

function _mainWithoutReact() {
  _mainWithoutReact = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return copyAssets();

          case 2:
            _context2.next = 4;
            return _fs.default.promises.rename(inputFileName, outputFileName);

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _mainWithoutReact.apply(this, arguments);
}

function mainWithReact() {
  return _mainWithReact.apply(this, arguments);
}

function _mainWithReact() {
  _mainWithReact = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
    var ReactApp, reactElement, file, _file$split, _file$split2, head, tail, ssr;

    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return copyAssets();

          case 2:
            ReactApp = require(_path.default.resolve("", "./dist/static/".concat(page, "/ssr/main"))).default;
            reactElement = React.createElement(ReactApp);
            console.log("DIR", __dirname);
            file = _fs.default.readFileSync(inputFileName, "utf8");
            _file$split = file.split("{react-app}"), _file$split2 = _slicedToArray(_file$split, 2), head = _file$split2[0], tail = _file$split2[1];
            ssr = '';

            try {
              ssr = renderToString(reactElement);
            } catch (ex) {
              console.warn(ex);
            }

            _fs.default.writeFileSync(outputFileName, head + ssr + tail, 'utf8');

          case 10:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _mainWithReact.apply(this, arguments);
}

if (NOREACT) {
  mainWithoutReact().then(function () {
    return console.log('✅ NOREACT build is done!');
  }).catch(function (err) {
    return console.error(err);
  });
} else {
  mainWithReact().then(function () {
    return console.log('✅React build is done!');
  }).catch(function (err) {
    return console.error(err);
  });
}