"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.weak-map");

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.regexp.replace");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

var _fs = _interopRequireDefault(require("fs"));

var _axios = _interopRequireDefault(require("axios"));

var _path = _interopRequireDefault(require("path"));

var _glob = _interopRequireDefault(require("glob"));

var _s = _interopRequireDefault(require("aws-sdk/clients/s3"));

var _slugify = _interopRequireDefault(require("slugify"));

var _tinyAsyncPool = _interopRequireDefault(require("tiny-async-pool"));

var _mimeTypes = _interopRequireDefault(require("mime-types"));

var envfile = _interopRequireWildcard(require("envfile"));

var _child_process = require("child_process");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var execute = function execute(command, callback) {
  (0, _child_process.exec)(command, function (error, stdout, stderr) {
    return callback(stdout);
  });
};

var env = envfile.parseFileSync(_path.default.resolve("", '.env'));

var toPromise = function toPromise(f) {
  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return new Promise(function (resolve, reject) {
      f.apply(void 0, args.concat([function (err, res) {
        return !!err ? reject(err) : resolve(res);
      }]));
    });
  };
}; //console.log("ENV", env);


var client = new _s.default({
  accessKeyId: process.env.osui_aws_access_key_id,
  secretAccessKey: process.env.osui_secret_access_key
});
var country = env.country,
    page = env.page,
    scenario = env.scenario,
    strategy = env.strategy,
    scenariosConfig = env.scenariosConfig;
var slugifiedString = scenario ? (0, _slugify.default)(scenario, {
  lower: true
}) : (0, _slugify.default)("".concat(strategy, "_").concat(scenariosConfig), {
  lower: true
});

var upload = function upload(_ref) {
  var key = _ref.key,
      file = _ref.file;
  console.log("KEY", key);
  console.log("FILE", file);
  var cacheControl = /\.html$/.test(file) ? 'max-age=1' : 'max-age=604800';
  console.log('🔼', key, cacheControl);
  return client.upload({
    Bucket: 'mobirun',
    Key: "os-ui".concat(key),
    Body: _fs.default.createReadStream(file),
    ACL: 'public-read',
    ContentType: _mimeTypes.default.contentType(_path.default.extname(file)),
    CacheControl: cacheControl
  }).promise();
};

function main() {
  return _main.apply(this, arguments);
}

function _main() {
  _main = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
    var root, files, htmlFileName, s3HtmlUrl, uploadResult, apiUrl, savePageUploadRecord, createCampaign;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            root = _path.default.resolve('dist');
            _context3.next = 3;
            return toPromise(_glob.default)(root + "/static/**/*.*", {
              nodir: true
            });

          case 3:
            files = _context3.sent;
            htmlFileName = "".concat(country, "-").concat(slugifiedString, "-staging.html");
            s3HtmlUrl = "https://s3.eu-central-1.amazonaws.com/mobirun/os-ui/static/".concat(page, "/html/").concat(htmlFileName);
            _context3.next = 8;
            return (0, _tinyAsyncPool.default)(4, files.map(function (f) {
              return {
                key: f.replace(root, ''),
                file: f
              };
            }), upload);

          case 8:
            uploadResult = _context3.sent;
            console.log("\u2705  # ".concat(uploadResult.length, " Uploaded!")); //console.log(`🔗 # http://staging.ouisys.com/preview/?country=${country}&page=${page}&scenario=${slugifiedScenario}`);

            console.log(s3HtmlUrl); //const apiUrl = "http://127.0.0.1:3030";

            apiUrl = "https://c1.ouisys.com"; //save the page upload to the database

            savePageUploadRecord = function savePageUploadRecord() {
              execute("git config --global user.name", function (name) {
                execute("git config --global user.email", function (email) {
                  execute("git config --get remote.origin.url", /*#__PURE__*/function () {
                    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(git_origin) {
                      var data, res, campaign;
                      return regeneratorRuntime.wrap(function _callee$(_context) {
                        while (1) {
                          switch (_context.prev = _context.next) {
                            case 0:
                              data = {
                                page: page,
                                country: country,
                                scenario: scenario ? slugifiedString : null,
                                strategy: strategy || null,
                                scenarios_config: scenariosConfig || null,
                                html_url: s3HtmlUrl,
                                git_username: name.replace("\n", ""),
                                //email: email.replace("\n", ""),
                                git_origin: git_origin.replace("\n", "")
                              };
                              _context.prev = 1;
                              _context.next = 4;
                              return (0, _axios.default)({
                                url: "".concat(apiUrl, "/api/v1/upload-page"),
                                method: 'post',
                                data: _objectSpread({
                                  env_dump: JSON.stringify(env)
                                }, data)
                              });

                            case 4:
                              res = _context.sent;

                              if (!res) {
                                _context.next = 11;
                                break;
                              }

                              _context.next = 8;
                              return (0, _axios.default)({
                                //url:'https://c1.ouisys.com/api/v1/create-campaign',
                                url: "".concat(apiUrl, "/api/v1/create-campaign"),
                                method: 'post',
                                data: _objectSpread({
                                  affid: "SAM"
                                }, data)
                              });

                            case 8:
                              campaign = _context.sent;
                              console.log("\uD83D\uDD17 # http://staging.ouisys.com/".concat(campaign.data.xcid));
                              console.log("upload record saved! 😁");

                            case 11:
                              return _context.abrupt("return", res);

                            case 14:
                              _context.prev = 14;
                              _context.t0 = _context["catch"](1);

                              if (!(_context.t0.response.status !== 500)) {
                                _context.next = 18;
                                break;
                              }

                              throw console.log(_context.t0);

                            case 18:
                            case "end":
                              return _context.stop();
                          }
                        }
                      }, _callee, null, [[1, 14]]);
                    }));

                    return function (_x) {
                      return _ref2.apply(this, arguments);
                    };
                  }());
                });
              });
            };

            savePageUploadRecord(); //create a campaign

            createCampaign = function createCampaign() {
              execute("git config --global user.name", function (name) {
                execute("git config --global user.email", function (email) {
                  execute("git config --get remote.origin.url", /*#__PURE__*/function () {
                    var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(git_origin) {
                      var data, res;
                      return regeneratorRuntime.wrap(function _callee2$(_context2) {
                        while (1) {
                          switch (_context2.prev = _context2.next) {
                            case 0:
                              data = {
                                page: page,
                                country: country,
                                scenario: scenario ? slugifiedString : null,
                                strategy: strategy || null,
                                scenarios_config: scenariosConfig || null,
                                affid: "SAM",
                                comments: "Build upload by name"
                              };
                              _context2.prev = 1;
                              _context2.next = 4;
                              return (0, _axios.default)({
                                url: "".concat(apiUrl, "/api/v1/create-campaign"),
                                method: 'post',
                                data: data
                              });

                            case 4:
                              res = _context2.sent;
                              console.log("campaign created under affid - SAM!");
                              console.log("STAGING URL \uD83D\uDD17 # http://staging.ouisys.com/".concat(res.data.xcid));
                              return _context2.abrupt("return", res);

                            case 10:
                              _context2.prev = 10;
                              _context2.t0 = _context2["catch"](1);
                              console.error(_context2.t0); //need tofix 

                              if (_context2.t0.response.status !== 500) {
                                console.log("Failed to save upload record", _context2.t0);
                              }

                            case 14:
                            case "end":
                              return _context2.stop();
                          }
                        }
                      }, _callee2, null, [[1, 10]]);
                    }));

                    return function (_x2) {
                      return _ref3.apply(this, arguments);
                    };
                  }());
                });
              });
            };

            createCampaign();

          case 16:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _main.apply(this, arguments);
}

main().then(function () {
  return console.log("");
}).catch(console.error);