import queryString from "./queryString";
import { IFlowEvent } from "./types";
export { queryString };
export declare function recordImpression(window: Window, url: string, country: string, page: string): import("./types").IPacmanAnalytics;
export declare function recordEvent(window: Window, url: string, view: string, flowEvent: IFlowEvent): void;
export declare type ITracker = {
    viewChanged: (view: string) => void;
    msisdnSubmitted: (msisdn: string) => void;
    advancedInFlow: (flow: string, action: string, args?: any) => void;
    advancedInPreFlow: (label: string, args?: any) => void;
    recedeInFlow: (flow: string, newState: string, args?: any) => void;
    customEvent: (category: string, action: string, label: string, arg?: any) => void;
};
declare const _default: (window: Window, country: string, page: string) => ITracker;
export default _default;
