import * as React from "react";

type Legals = {
  id: number,
  country: string,
  service: string,
  scenario: string,
  language: string,
  top_legal: string,
  price_point: string,
  disclaimer: string,
  date_created: string,
  extra_disclaimer: string,
  flow?:string,
};

type ILegalProps = {
  locale:string, 
  legals:Array<Legals>,
  className?:string,
  flow?:string,
}
export default ({locale, className, legals, flow}:ILegalProps) => {

  const filteredLegals = legals.filter((obj)=>obj.flow === flow);

  const legalsArr = flow ? filteredLegals : legals;
  const arrayToObject = (array) =>
   array.reduce((obj, item) => {
     obj[item.language] = item
     return obj
   }, {});
  
  const legalsObject = arrayToObject(legalsArr)
  const { top_legal } = legalsObject[locale] || "";
  return (
    <div className={className || ""}>
      <div dangerouslySetInnerHTML={ { __html: top_legal } }></div>
    </div>
  )
};
