import * as path from 'path'
import * as envfile from "envfile"
import setPageStrategyConfig from "./configure-page-strategy";
import setPageScenarioConfig from "./configure-page-scenario";

const env = envfile.parseFileSync(path.resolve("", '.env'))
const client = env.client

const strategyBasedClients = [
  "super-strategy"
]
const scenarioBasedClients = [
  "assrock-mo",
  "assrock-pin",
  "bupper-click2sms",
  "bupper-one-click",
  "tallyman.v1-pin",
  "tola-mpesa",
  "tallyman.v1-moredir",
  "tallyman.v1-mo",
  "tallyman.v1-click2sms",
  "tallyman.v1-one-click",
  "tallyman.v1-click-redir"
]

if(!!client){
  if(strategyBasedClients.includes(client)){
    setPageStrategyConfig(client)
    .then((res)=>{
      console.log("res")
    })
    .catch((err)=>{
      console.log("err", err) ;
    });
  }
  if(scenarioBasedClients.includes(client)){
    console.log("")
    setPageScenarioConfig(client)
    .then((res)=>{
      console.log("res")
    })
    .catch((err)=>{
      console.log("err", err) ;
    });
  }
  
}else{
  throw `Please specify a client in .env file.`;
}
