import IVisitor from "../common-types/IVisitor";
import queryString from "../pacman/queryString";

export default async function tryGetIPRangeName(visitor: IVisitor): Promise<string> {
  
  const mockip =  queryString(window.location.href, "mock-ip");
  console.log("mockip", mockip)
  if (!visitor.ip) {
    try {
      const res = await fetch('https://c1.ouisys.com/api/v1/ip' + (!!mockip ? `?mock-ip=${mockip}` : "")).then(x => x.json())
      // return isIPInRange('37.200.146.28')
      visitor.ip = res.ip
      visitor.ip_range_name = res.ip_range_name
      return res.ip_range_name
    } catch (ex) {
      console.warn("IP Lookup failed", ex)
    }
  } else {
    return visitor.ip_range_name
  }
}