import IVisitor from "../common-types/IVisitor";

export interface IFlowEvent {
    category: string;
    action?: string;
    label?: string;
    value?: number;
    args?: any;
}

export interface IPacmanAnalytics {
    visitor: IVisitor;
    userId: string;
    encCampaignId: string;
    originalUrl: string;
    url: string;
    startTime: number;
    queryString: (key) => string;
}

export interface IPacman {
    initInteractions: () => void;
    sendPageview: () => void;
    sendFlowEvent: (flowEvent: IFlowEvent) => void;
}